#define VERTRANGEMAX 32768
#define VERTRANGE 100
#define MAXFILENAME 513
#define SELF "QuineMcC"
#define VSN "1.00"
#define NAME "Martin Carradus"
#define COMPANY "Leaf Mindcraft"
#define MYDATE "4th July 2010"
#define BRIEF "Quine McCluskey Logic Optimisation"
#define XDefault  48
#define YDefault  48
#define IDefault   100
#define IDIM1_I 1023
#define JDIM1_I 1023
#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <windef.h>
#include <wingdi.h>
#include <winbase.h>
#include <winuser.h>
#include <commdlg.h>
#include <commctrl.h>
#include <math.h>
#include <time.h>
#include "menu.h"
#include "format.h"
#include "print.h"

static char szTemp[MAXFILENAME];
static char szFileOut[MAXFILENAME]="";
static HINSTANCE hInst;
static HINSTANCE hkarnaughInst;
static HINSTANCE hlogicInst;
static HINSTANCE hhelpInst;
static HWND hwnd;               /* This is the handle for our window */
static BOOL Help=FALSE;
static BOOL Begin=FALSE;
static MSG helpmessages;
static MSG progmessages;
static MSG karnaughmessages;
static MSG logicmessages;
static HWND helpwind;
static HWND progwind;
static HWND setupwind;
static HWND karnaughwind;
static HWND mainwind;
static HWND logicwind;
static HWND hComboCtrl;
static int helpFunsterStil;
static int progFunsterStil;
static int karnaughFunsterStil;
static int logicFunsterStil;
static int maxX,maxY;
static int DY;
static int Logiclen;
static HDC memDC1;
static HDC memDC2;
static HDC memDC3;
static HDC memDC4;
static HDC memDC5;
static HDC painthdc;
static HDC hdc;
static HDC logicdc;
static HDC karnaughdc;
static HBITMAP hbit;
static HBITMAP hbit1;
static HBITMAP hbit2;
static HBITMAP hbit3;
static HBITMAP hbit4;
static PBITMAPINFO pbmi;
static TEXTMETRIC tm;
static double VidXPPI,VidYPPI,PrXPPI,PrYPPI;
static double Xratio, Yratio;
static double vpos=0.0;
static double OldVpos=0.0;
static double VPos=0.0;
static double hpos=0.0;
static double Oldhpos=0.0;
static double HPos=0.0;
static LONG width=VERTRANGE;
static LONG height=VERTRANGE;
static int xheight;
HFONT g_hfFont = NULL;
BOOL g_bOpaque = TRUE;
COLORREF g_rgbText = RGB(255, 0, 0);
COLORREF g_rgbBackground = RGB(255, 255, 255);
COLORREF g_rgbCustom[16] = {0};
HFONT g_hfhelpFont = NULL;
HFONT g_hfprogFont = NULL;
HFONT g_hfkarnaughFont = NULL;
HFONT g_hfLogicFont = NULL;
BOOL g_bhelpOpaque = TRUE;
BOOL g_bprogOpaque = TRUE;
BOOL g_bkarnaughOpaque = TRUE;
BOOL g_blogicOpaque = TRUE;
COLORREF g_rgbhelpText = RGB(0, 0, 255);
COLORREF g_rgbhelpBackground = RGB(255, 255, 255);
COLORREF g_rgbhelpCustom[16] = {0};
COLORREF g_rgbprogText = RGB(0, 0, 255);
COLORREF g_rgbprogBackground = RGB(255, 255, 255);
COLORREF g_rgbprogCustom[16] = {0};
COLORREF g_rgbkarnaughText = RGB(0, 0, 255);
COLORREF g_rgbkarnaughBackground = RGB(255, 255, 255);
COLORREF g_rgbkarnaughCustom[16] = {0};
COLORREF g_rgbLogicText = RGB(0, 0, 255);
COLORREF g_rgbLogicBackground = RGB(255, 255, 255);
COLORREF g_rgbLogicCustom[16] = {0};
static BOOL Opened=FALSE;
static BOOL Descript=FALSE;
static BOOL Done=FALSE;
static BOOL Run=FALSE;
static BOOL description=FALSE;
static BOOL Closed=FALSE;
static BOOL initialised=FALSE;
static BOOL iappend=FALSE;
static BOOL inew=TRUE;
static BOOL idelete=FALSE;
static BOOL Next=FALSE;
static BOOL Set=FALSE;
static BOOL SetUp=FALSE;
static BOOL SetUpLegend=FALSE;
static BOOL RunLegend=FALSE;
static BOOL Running=FALSE;
static BOOL Accept=FALSE;
static BOOL Start=FALSE;
static BOOL Karnaugh=FALSE;
static BOOL KarnaughSetUp=FALSE;
static BOOL Progress=FALSE;
static BOOL error=FALSE;
static BOOL Reset=FALSE;
static BOOL First=TRUE;
static BOOL Finished=FALSE;
static BOOL SaveOptions=BST_UNCHECKED;
static BOOL Logic=FALSE;
static int x=48,y=48;
static int prev_x,prev_y;
static int idim1_i=47,jdim1_i=47;
static double factor=0.46875;
static double size;
static int karnaugh_area_size;
static int iplot=0;
static int Width_1,Height_1;
static int loop_count_i;
static int keycode=0;
static int KarnaughMap[4][4]={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
static int B[4][4]={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
static char *logicstring;
static FILE *fchan;
static HACCEL hAccel;
static HACCEL hKarnaughAccel;
static HACCEL hLogicAccel;
static double factor0x,factor1x,factor2x;
static double factor0y,factor1y,factor2y;
size_t maxsize=50;
time_t *timer;
struct tm *timeptr;
char *timestr;
DWORD Tid;
HANDLE hSema;

struct logicrec
{int *logic;
  struct logicrec *next;
  };
  
typedef struct logicrec logicrec;

logicrec *logictable[5][5]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};

int lookup[4][2]={0,0,0,1,1,1,1,0};

int logicrecount[5][5]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
static logicrec *ptr;
static logicrec *ptrnext;

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DialogFunc4(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WndProc4(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
PBITMAPINFO CreateBitmapInfoStruct(HWND hwnd, HBITMAP hBmp);
void CreateBMPFile(HWND hwnd, LPTSTR pszFile, PBITMAPINFO pbi,
                  HBITMAP hBMP, HDC hDC);

/*  Make the class name into a global variable  */
char szClassName[ ] = "WindowsApp";
char szHelpClassName[ ]="HelpApp";
char szProgClassName[ ]="ProgApp";
char szKarnaughClassName[ ]="KarnaughApp";
char szLogicClassName[ ]="LogicApp";
static char *szformat="\x0d\n  \xa9 Martin Carradus, Leaf Mindcraft 2010\x0d\n \x0d\n  QuineMcC - Version %s, %s.\x0d\n  ~~~~~~~\x0d\n Uses the Quine-McCluskey Algorithm to Simplify a Logic Function.\x0d\n\x0d\n Give an Initial Karnaugh Map in the \'K Map\' Window. (Toggle the values by clicking Mouse on Cells.)\x0d\n\x0d\n";
static char *szInfoLine[3]={""," Then Click \'Run QuineMcC\',\x0d\n\x0d\n and the Optimisation Begins. \x0d\n\x0d\n A Window appears, which Gives the Optimised Canonical Boolean Expression for the Function.\x0d\n\x0d\n In this \'Boolean\' Expression, a dot denotes an AND, a '+' denotes an OR and a ~ denotes NOT.\x0d\n\x0d\n The \'Canonical\' Form for the Expression, is a series of ANDEd Groups, which are ORed together.\x0d\n\x0d\n Click \'Help\' or Press F1 for information window.\x0d\n\x0d\n N.B. You can ONLY choose \'Run QuineMcC\' once the Karnaugh Map has been Altered, in some way.\x0d\n\x0d\n",
                         " Comments, queries, curses, praise to:-\x0d\n\x0d\n       Martin Carradus,\x0d\n       Leaf Mindcraft,\x0d\n       c/o Flat 2, Hilton House,\x0d\n       3-5 Kirkgate, SILSDEN,\x0d\n       W. Yorks. BD20 0AJ. U.K.\x0d\n  Enclose s.a.e. for reply.\x0d\n\x0d\n Web Site URL \'http://www.leaf.mindcraft.freeuk.com\'.\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n"};

void errhandler(char *szRoutine,HWND hwnd)
{char message[301];
if(SetUp){ReleaseDC(hwnd,memDC3);
          DeleteObject(hbit);};
            sprintf(message,"Fatal Error in Function %s - Aborting.",szRoutine);
            MessageBox(hwnd,message,"Fatal Error from QuineMcC",MB_OK);
            if(Help)DestroyWindow(helpwind);
			PostQuitMessage(0);
}

int Quinemin(int a, int b, int *flag, int *amount)
{if(a<=b){*flag=0;*amount=0;return(a);}
 *flag=1;
 *amount=a-b;
 return(b);
}

int Quinemax(int a, int b, int *flag, int *amount)
{if(a>=b){*flag=0;*amount=0;return(a);}
 *flag=1;
 *amount=b-a;
 return(b);
}


int QuineMcCircle(HDC memDC, int x, int y, int distance, int length, int orientation)
{static int offset[4][2]={{3,0},{0,1},{1,0},{0,3}};
 int i,j,ii;
 int upX,upXX,upY,lowX,lowXX,lowY;
 int startX,startY,endX,endY;
 HPEN hPen;
 i=(x+((offset[orientation][1]*distance+length)%4))*100+75;
 ii=(x+((offset[orientation][1]*distance+length*3)%4))*100+75;
 j=(y+((offset[orientation][0]*distance)%4))*100+75;
 hPen=CreatePen(PS_SOLID,5,RGB(0,0,255));
 upX=i+40;upY=j+40;lowX=i-40;lowY=j-40;
 upXX=ii+40;lowXX=ii-40;
if(orientation==0){
 	startX=upX;startY=j;
 	endX=i;endY=lowY;
 } else if(orientation==1){
 	startX=i;startY=lowY;
 	endX=lowX;endY=j;
 } else if(orientation==2){
 	startX=lowXX;startY=j;
 	endX=ii;endY=upY;
 } else {
 	startX=ii;startY=upY;
 	endX=upXX;endY=j;
 };
 SelectObject(memDC,hPen); 
 Arc(memDC,upX,upY,lowX,lowY,startX,startY,endX,endY);
 return(0);
}

/* int QuineMcLine(HDC memDC,int x, int y, int distance, int length, int orientation)
{static int offset[4][2][2]={{{3,0},{1,0}},{{0,1},{0,3}},{{1,0},{3,0}},{{0,3},{0,1}}};
 int i[2],j[2],ii[2],iii[2],jj[2],jjj[2];
 int startX,startY,endX,endY;
  int flag,amount;
  HPEN hPen;
 i[0]=(x+((offset[orientation][0][1]*distance)%4))*100+25;
 ii[0]=((x+((offset[orientation][0][1]*distance)%4)+length*((orientation+1)%2)))*100+25;
 iii[0]=((x+((offset[orientation][0][1]*distance)%4)-length*((orientation+1)%2)))*100+25;
 j[0]=(y+((offset[orientation][1][0]*distance+(1+orientation)*((1+orientation)%2)))%4)*100-(90-40*orientation)*((orientation+1)%2)+25;
 jj[0]=(y+((offset[orientation][1][0]*distance+(1+orientation)*((1+orientation)%2))%4)+length*(orientation%2))*100-(90-40*orientation)*((orientation+1)%2)+25;
 jjj[0]=(y+((offset[orientation][1][0]*distance+(1+orientation)*((1+orientation)%2))%4)-length*(orientation%2))*100-(90-40*orientation)*((orientation+1)%2)+25;
 i[1]=(x+((offset[orientation][1][1]*distance+(3-orientation)*(orientation%2)))%4)*100+25;
 ii[1]=(x+((offset[orientation][1][1]*distance+(3-orientation)*(orientation%2))%4)+length*((orientation+1)%2))*100+25;
 iii[1]=(x+((offset[orientation][1][1]*distance+(3-orientation)*(orientation%2))%4)-length*((orientation+1)%2))*100+25;
 j[1]=(y+((offset[orientation][0][0]*distance)%4))*100+25;
 jj[1]=(y+((offset[orientation][0][0]*distance)%4)+length*(orientation%2))*100+25;
 jjj[1]=(y+((offset[orientation][0][0]*distance)%4)-length*(orientation%2))*100+25;
 hPen=CreatePen(PS_SOLID,5,RGB(0,0,255));
 SelectObject(memDC,hPen);
 if(orientation==0){
 	startX=i[0];startY=j[0];
 	endX=Quinemin(ii[0],400,&flag,&amount);endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=0;startY=j[0];
 	endX=amount;endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 	startX=i[0];startY=j[0];
 	endX=Quinemax(iii[0],25,&flag,&amount);endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=400;startY=j[0];
 	endX=400-amount;endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 } else if(orientation==1){
 	startX=i[1];startY=j[1];
 	endX=i[1];endY=Quinemin(jj[1],400,&flag,&amount);
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=i[1];startY=0;
 	endX=i[1];endY=amount;
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 	startX=i[1];startY=j[1];
 	endX=i[1];endY=Quinemax(jjj[1],25,&flag,&amount);
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=i[1];startY=400;
 	endX=i[1];endY=400-amount;
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 } else if(orientation==2){
 	startX=i[0];startY=j[0];
 	endX=Quinemin(ii[0],400,&flag,&amount);endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=0;startY=j[0];
 	endX=amount;endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 	startX=i[0];startY=j[0];
 	endX=Quinemax(iii[0],25,&flag,&amount);endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=400;startY=j[0];
 	endX=400-amount;endY=j[0];
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 } else {
 	startX=i[1];startY=j[1];
 	endX=i[1];endY=Quinemin(jj[1],400,&flag,&amount);
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=i[1];startY=0;
 	endX=i[1];endY=amount;
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 	startX=i[1];startY=j[1];
 	endX=i[1];endY=Quinemax(jjj[1],25,&flag,&amount);
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	if(flag){startX=i[1];startY=400;
 	endX=i[1];endY=400-amount;
 	MoveToEx(memDC,startX,startY,NULL);LineTo(memDC,endX,endY);
 	}
 }
 	return(0);
 }*/
 
 int QuineMcCLogic(HDC memDC,int row,int col,int width,int height)
 {
  int lowX,lowY,upX,upY;
  int ElowX,ElowY,EupX,EupY;
  int EstartX,EstartY,EendX,EendY;
   lowX=col*100+25;lowY=row*100+25;
   upX=lowX+width*100;upY=lowY+height*100;
   if(height!=1){MoveToEx(memDC,upX-10,upY-50,NULL);LineTo(memDC,upX-10,lowY+50);
   MoveToEx(memDC,lowX+10,lowY+50,NULL);LineTo(memDC,lowX+10,upY-50);};
   if(width!=1){MoveToEx(memDC,lowX+50,lowY+10,NULL);LineTo(memDC,upX-50,lowY+10);       
   MoveToEx(memDC,upX-50,upY-10,NULL);LineTo(memDC,lowX+50,upY-10);};
   /* Lower left hand corner */
   ElowX=lowX+10;ElowY=lowY+10;EupX=lowX+100;EupY=lowY+100;
   EendX=lowX-10;EendY=lowY+50;EstartX=lowX+50;EstartY=lowY-10;
   Arc(memDC,EupX,EupY,ElowX,ElowY,EstartX,EstartY,EendX,EendY);
   /* Upper left hand corner */       
   EupX=lowX+10;EupY=upY-10;ElowX=lowX+100;ElowY=upY-100;
   EstartX=lowX-10;EstartY=upY-50;EendX=lowX+50;EendY=upY+10;       
   Arc(memDC,EupX,EupY,ElowX,ElowY,EstartX,EstartY,EendX,EendY);
   /* Upper right hand corner */
   ElowX=upX-100;ElowY=upY-100;EupX=upX-10;EupY=upY-10;
   EstartX=upX-50;EstartY=upY+10;EendX=upX+10;EendY=upY-50;
   Arc(memDC,EupX,EupY,ElowX,ElowY,EstartX,EstartY,EendX,EendY);
   /* Lower right hand corner */
   ElowX=upX-10;ElowY=lowY+10;EupX=upX-100;EupY=lowY+100;
   EendX=upX-50;EendY=lowY-50;EstartX=upX+10;EstartY=lowY+50;
   Arc(memDC,EupX,EupY,ElowX,ElowY,EstartX,EstartY,EendX,EendY);
   return(0);
 }
 
int and(int *first, int *second)
{int i;
  if(first[4]==1 || second[4]==1)return(-1);
   for(i=0;i<4;i++)
  {if(first[i]==-3 || second[i]==-3);
   else if(first[i]!=second[i])return(0); 
    };
return(1);
}

int and2(int *first, int *second)
{int i;
  if(first[4]==1 || second[4]==1)return(-1);
   for(i=0;i<4;i++)
  {if(first[i]!=second[i])return(0);  
    };
return(1);
}


/* int delete(logicrec *prev,logicrec *ptr,int i, int j)
{if(prev==(logicrec *)EOF)
  {free(ptr->logic);
    free(ptr);
    logictable[i][j]=NULL;
    } else {
    prev->next=ptr->next;    
    free(ptr->logic);
    free(ptr);
    };
return(0);
}*/

int alter(int type,int row_i,int col_i,int width,int height)
{int i,j;
    for(i=0;i<width;i++)
      {for(j=0;j<height;j++)
        {if(type==0)B[col_i-2+i][row_i-1+j]+=1;
          else if(type==1)B[col_i-2+i][row_i-1+j]-=1;
          else if(B[col_i-2+i][row_i-1+j]==1)return(1);
          }
        }
return(0);
}

int check(int type,int i,logicrec *ptr)
{int flag=0;
  int k,l,m,n;
  int col_i,row_i;
  
  if(i==0){
          for(k=0;k<4 && (lookup[k][0]!=ptr->logic[0] || lookup[k][1]!=ptr->logic[1]);k++);
          for(l=0;l<4 && (lookup[l][0]!=ptr->logic[2] || lookup[l][1]!=ptr->logic[3]);l++);
          col_i=2+k;row_i=4-l;
        flag=alter(type,row_i,col_i,1,1);
           } else if(i==1)
          {for(k=0;k<4 && ptr->logic[k]!=-3;k++);
            if(k<2){/* Horizontal */
              k=1-k;
            for(l=0;ptr->logic[2]!=lookup[l][0] || ptr->logic[3]!=lookup[l][1];l++);
            for(m=0;ptr->logic[k]!=lookup[m][k];m++);
            if(k==0 || (k==1 && m==1))
            {col_i=2+m;row_i=4-l;
        flag=alter(type,row_i,col_i,2,1);
      } else {col_i=2;row_i=4-l;
        flag=alter(type,row_i,col_i,1,1);
        col_i=5;row_i=4-l;
        flag=flag | alter(type,row_i,col_i,1,1);
           }
              } else {/* Vertical */
              k=5-k;
               for(l=0;ptr->logic[0]!=lookup[l][0] || ptr->logic[1]!=lookup[l][1];l++);
               for(m=0;m<4 && ptr->logic[k]!=lookup[m][k-2];m++);
              if(k==2 || (k==3 && m==1))
              {col_i=2+l;row_i=3-m;
        flag=alter(type,row_i,col_i,1,2);
                } else {col_i=2+l;row_i=1;
        flag=alter(type,row_i,col_i,1,1);
        col_i=2+l;row_i=4;
        flag=flag | alter(type,row_i,col_i,1,1);
                }
              }
          } else if(i==2)
          {if(ptr->logic[0]==-3 && ptr->logic[1]==-3)
            {
          for(l=0;l<4 && (lookup[l][0]!=ptr->logic[2] || lookup[l][1]!=ptr->logic[3]);l++);
          col_i=2;row_i=4-l;
        flag=alter(type,row_i,col_i,4,1);
              } else if(ptr->logic[2]==-3 && ptr->logic[3]==-3){
              for(k=0;k<4 && (lookup[k][0]!=ptr->logic[0] || lookup[k][1]!=ptr->logic[1]);k++);
          col_i=2+k;row_i=1;
        flag=alter(type,row_i,col_i,1,4);
            } else {for(k=0;ptr->logic[k]==-3;k++);
                        for(l=2;ptr->logic[l]==-3;l++);
                        for(m=0;m<4 && lookup[m][k]!=ptr->logic[k];m++);
                        for(n=0;n<4 && lookup[n][l%2]!=ptr->logic[l];n++);
             if((k==0 || k==1 && ptr->logic[k]==1) && (l%2==0 || l%2==1 && ptr->logic[l]==1))
             {row_i=3-n;col_i=2+m;
              flag=alter(type,row_i,col_i,2,2);
               } else if(k==0 || k==1 && ptr->logic[k]==1)
               {row_i=1;col_i=2+m;
        flag=alter(type,row_i,col_i,2,1);
        row_i=4;col_i=2+m;
                       flag=flag | alter(type,row_i,col_i,2,1);
                 } else if(l%2==0 || l%2==1 && ptr->logic[l]==1)
                 {row_i=3-n;col_i=2;
              flag=alter(type,row_i,col_i,1,2);
        row_i=3-n;col_i=5;
        flag=flag | alter(type,row_i,col_i,1,2);
                   } else {
                          row_i=1;col_i=2;
              flag=alter(type,row_i,col_i,1,1);
        row_i=1;col_i=5;
        flag=flag | alter(type,row_i,col_i,1,1);
        row_i=4;col_i=5;
              flag=flag | alter(type,row_i,col_i,1,1);
        row_i=4;col_i=2;
              flag=flag | alter(type,row_i,col_i,1,1);
                   }              }
            } else if(i==3)
            {for(k=0;ptr->logic[k]==-3;k++);
              l=k%2;
              for(m=0;m<4 && lookup[m][l]!=ptr->logic[k];m++);
              if(k/2==0)
              {if(l==0 || l==1 && ptr->logic[k]==1)
                {row_i=1;col_i=2+m;
        flag=alter(type,row_i,col_i,2,4);
                  } else {
                  row_i=1;col_i=2;
        flag=alter(type,row_i,col_i,1,4);
                  row_i=1;col_i=5;
        flag=flag | alter(type,row_i,col_i,1,4);
                  }
                } else {
                if(l==0 || l==1 && ptr->logic[k]==1)
                {row_i=3-m;col_i=2;
        flag=alter(type,row_i,col_i,4,2);
                  } else {
                  row_i=1;col_i=2;
        flag=alter(type,row_i,col_i,4,1);
                  row_i=4;col_i=2;
        flag=flag | alter(type,row_i,col_i,4,1);
                   }
                }
              }
  return(flag);
}   


/* int compare2(int *first,int *second)
{int i,j,k;
  j=0;k=0;
  for(i=0;i<4;i++)
  {if(first[i]==-3)j++;
    if(second[i]==-3)k++;
    };
if(j>k)return(1);
if(j==k)return(0);
return(-1);
}*/

int tidyup(void)
{logicrec *prev0,*ptr0,*prev1,*ptr1,*prev2,*ptr2;
  int i0,j0,i1,j1,i2,j2;
  for(i0=0;i0<4;i0++)
  {for(j0=0;j0<5;j0++)
    {prev0=(logicrec *)EOF;
      ptr0=logictable[i0][j0];
      while(ptr0!=NULL){
      for(i1=0;i1<4;i1++)
    {for(j1=0;j1<5;j1++)
  {prev1=(logicrec *)EOF;
      ptr1=logictable[i1][j1];
    while(ptr1!=NULL){
      for(i2=0;i2<4;i2++)
    {for(j2=0;j2<5;j2++)
    {prev2=(logicrec *)EOF;
      ptr2=logictable[i2][j2];
   while(ptr2!=NULL){
     if(and(ptr0->logic,ptr2->logic)==1 && and(ptr1->logic,ptr2->logic)==1 && and(ptr0->logic,ptr1->logic)==0 && and2(ptr0->logic,ptr1->logic)==0 && and2(ptr0->logic,ptr2->logic)==0 && and2(ptr1->logic,ptr2->logic)==0 && !check(2,i2,ptr2)){check(1,i2,ptr2);ptr2->logic[4]=1;}
   prev2=ptr2;
   ptr2=ptr2->next;
   }
   }
   }
   prev1=ptr1;
   ptr1=ptr1->next;
   }
   }
   }
   prev0=ptr0;
   ptr0=ptr0->next;
   }
    }
    }
  return(0);  
}      

    
int equals(int *first,int *second)
{int i,j;
  j=0;
  for(i=0;i<4;i++)j+=(int)fabs((double)(first[i]-second[i]));
  if(j==0)return(1);
  return(0);
  }

int compare(logicrec *first,logicrec *second,logicrec **out)
{int i,j;
  j=0;
  for(i=0;i<4;i++)j+=(int)fabs((double)(first->logic[i]-second->logic[i]));
  if(j==1){first->logic[4]=1;second->logic[4]=1;
    *out=(logicrec *)malloc(sizeof(logicrec));
    (*out)->logic=(int *)malloc(5*sizeof(int));
    (*out)->logic[4]=0;
      for(i=0;i<4;i++)
      {if(first->logic[i]==second->logic[i])(*out)->logic[i]=first->logic[i];
        else (*out)->logic[i]=-3;
        }
      return(1);
      }  
return(0);
}

int logicount(int *first)
{int i,j;
  j=0;
  for(i=0;i<4;i++)j+=(first[i]>0);
  return(j);
  }

int add(int n,logicrec **ptr)
{int i;
  logicrec *ptr1;
  i=logicount((*ptr)->logic);
  if(logictable[n][i]==NULL)
  {(*ptr)->next=NULL;
    logictable[n][i]=*ptr;
    logicrecount[n][i]++;
    } else {ptr1=logictable[n][i];
    while(!equals((*ptr)->logic,ptr1->logic) && ptr1->next!=NULL)ptr1=ptr1->next;
    if(!equals((*ptr)->logic,ptr1->logic) && ptr1->next==NULL){(*ptr)->next=NULL;ptr1->next=*ptr;logicrecount[n][i]++;};
    }
     return(0);
}

int firstload(void)
{int i,j;
  for(i=0;i<4;i++)
  {for(j=0;j<4;j++)
    {if(KarnaughMap[3-j][i]==1){
          ptr=(logicrec *)malloc(sizeof(logicrec));
          ptr->logic=(int *)malloc(5*sizeof(int));
          ptr->logic[0]=lookup[i][0];
           ptr->logic[1]=lookup[i][1];
           ptr->logic[2]=lookup[3-j][0];
           ptr->logic[3]=lookup[3-j][1];
           ptr->logic[4]=0;
           add(0,&ptr);
             }
             B[i][j]=0;
           }
         }
 return(0);}

char *gatherup(void)
{int i,j,k,l,m;
  int len=0;
  logicrec *ptr;
  char mess[12];
  Begin=TRUE;
  logicstring=(char *)malloc(sizeof(char));
  strcpy(logicstring,(char *)"");
  for(i=0;i<=4;i++)
  {for(j=0;j<=4;j++)
  {ptr=logictable[i][j];
    while(ptr!=NULL)
    {if(ptr->logic[4]==0)
      {l=0;m=0;
        for(k=0;k<4;k++)
        {
          if(ptr->logic[k]!=-3){
            if(m!=0)mess[l++]='.';
            m++;
            if(ptr->logic[k]==0)mess[l++]='~';
            mess[l++]=(char)(65+k);
            }
            }
            mess[l]='\0';
     if(Begin){len=strlen(mess)+1;Begin=FALSE;free(logicstring);
       logicstring=(char *)malloc(len*sizeof(char));strcpy(logicstring,mess);}
     else {len+=strlen(mess)+3;logicstring=(char *)realloc(logicstring,len*sizeof(char));
       strcat(logicstring," + ");strcat(logicstring,mess);}
       }
       ptr=ptr->next;
       }
       }
       }
return(logicstring);
}       

int checks(void)
{int i,j;
  logicrec *ptr;
  for(i=0;i<=4;i++)
  {for(j=0;j<=4;j++)
  {ptr=logictable[i][j];
    while(ptr!=NULL)
    {if(ptr->logic[4]==0)
      {check(0,i,ptr);
       }
       ptr=ptr->next;
       }
       }
       }
return(0);
}

char *QMcCprocess(HDC memDC)
{int i,j,k,l,m,n;
int upX,upY,lowX,lowY;
int EupX,EupY,ElowX,ElowY;
 int EstartX,EstartY,EendX,EendY;
  logicrec *ptr1,*ptr2;
  /* double factorx,factory;
  double factorxx,factoryy;*/
  int x0,y0;
  int row_i,col_i;
   char name[13];
   HPEN hPen;
   firstload();
  for(i=0;i<4;i++)
  {for(j=0;j<4;j++)
    {ptr1=logictable[i][j];
        while(ptr1!=NULL){
       {ptr2=logictable[i][j+1];
          while(ptr2!=NULL){
          if(compare(ptr1,ptr2,&ptr))add(i+1,&ptr);
          ptr2=ptr2->next;
          }
          ptr1=ptr1->next;
         }
      }
     }
    }
  checks();  
  tidyup();
  logicstring=gatherup();
        /*winfo.w=displaywin_handle;
        wimp_get_wind_info(&winfo);
        x0=winfo.info.box.x0;
        y0=winfo.info.box.y0;
factorx=1.0/((double)(winfo.info.ex.x1-winfo.info.ex.x0)/(double)(winfo.info.box.x1-winfo.info.box.x0));
factory=1.0/((double)(winfo.info.ex.y1-winfo.info.ex.y0)/(double)(winfo.info.box.y1-winfo.info.box.y0));
*/hPen=CreatePen(PS_SOLID,5,RGB(0,0,255));
  SelectObject(memDC,hPen);
  for(i=0;i<=4;i++)
  {for(j=0;j<=4;j++)
  {ptr=logictable[i][j];
    while(ptr!=NULL)
    {if(ptr->logic[4]==0)
      {if(i==0){
          for(k=0;k<4 && (lookup[k][0]!=ptr->logic[0] || lookup[k][1]!=ptr->logic[1]);k++);
          for(l=0;l<4 && (lookup[l][0]!=ptr->logic[2] || lookup[l][1]!=ptr->logic[3]);l++);
          col_i=2+k;row_i=4-l;
          col_i-=2;row_i--;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCircle(memDC,col_i,3-row_i,0,0,0);
		  QuineMcCircle(memDC,col_i,3-row_i,0,0,1);
		  QuineMcCircle(memDC,col_i,3-row_i,0,0,2);
		  QuineMcCircle(memDC,col_i,3-row_i,0,0,3); 
     /* --- ask how the WIMP is going to scale plot sprite --- 
     strcpy(name,"a1x1");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occurred");*/
          } else if(i==1)
          {for(k=0;k<4 && ptr->logic[k]!=-3;k++);
            if(k<2){/* Horizontal */
              k=1-k;
            for(l=0;ptr->logic[2]!=lookup[l][0] || ptr->logic[3]!=lookup[l][1];l++);
            for(m=0;ptr->logic[k]!=lookup[m][k];m++);
            if(k==0 || (k==1 && m==1))
            {col_i=2+m;row_i=4-l;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,4-row_i,col_i-2,2,1);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x1");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)TwoWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
              } else {col_i=2;row_i=4-l;
          /* factorxx=factor0x+factor1x*(double)(col_i-2);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,4-row_i,col_i-3,2,1); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x1a");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
        col_i=5;row_i=4-l;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,4-row_i,col_i-2,2,1); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x1b");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
           }
              } else {/* Vertical */
              k=5-k;
               for(l=0;ptr->logic[0]!=lookup[l][0] || ptr->logic[1]!=lookup[l][1];l++);
               for(m=0;m<4 && ptr->logic[k]!=lookup[m][k-2];m++);
              if(k==2 || (k==3 && m==1))
              {col_i=2+l;row_i=3-m;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,3-row_i,col_i-2,1,2); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a1x2");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)TwoHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                } else {col_i=2+l;row_i=1;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,row_i-2,col_i-2,1,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x1c");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
        col_i=2+l;row_i=4;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,row_i-1,col_i-2,1,2); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x1d");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                }
              }
          } else if(i==2)
          {if(ptr->logic[0]==-3 && ptr->logic[1]==-3)
            {
          for(l=0;l<4 && (lookup[l][0]!=ptr->logic[2] || lookup[l][1]!=ptr->logic[3]);l++);
          col_i=2;row_i=4-l;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,4-row_i,col_i-2,4,1); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a4x1");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)FourWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
              } else if(ptr->logic[2]==-3 && ptr->logic[3]==-3){
              for(k=0;k<4 && (lookup[k][0]!=ptr->logic[0] || lookup[k][1]!=ptr->logic[1]);k++);
          col_i=2+k;row_i=1;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,row_i-1,col_i-2,1,4); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a1x4");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)FourHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
            } else {for(k=0;ptr->logic[k]==-3;k++);
                        for(l=2;ptr->logic[l]==-3;l++);
                        for(m=0;m<4 && lookup[m][k]!=ptr->logic[k];m++);
                        for(n=0;n<4 && lookup[n][l%2]!=ptr->logic[l];n++);
             if((k==0 || k==1 && ptr->logic[k]==1) && (l%2==0 || l%2==1 && ptr->logic[l]==1))
             {row_i=3-n;col_i=2+m;
                /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,3-row_i,col_i-2,2,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)TwoWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)TwoHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
               } else if(k==0 || k==1 && ptr->logic[k]==1)
               {row_i=1;col_i=2+m;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,row_i-2,col_i-2,2,2); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2c");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)TwoWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
        row_i=4;col_i=2+m;
        /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,row_i-1,col_i-2,2,2); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2d");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)TwoWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                 } else if(l%2==0 || l%2==1 && ptr->logic[l]==1)
                 {row_i=3-n;col_i=2;
                /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,3-row_i,col_i-3,2,2); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2a");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)TwoHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
        row_i=3-n;col_i=5;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,3-row_i,col_i-2,2,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2b");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)TwoHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                   } else {
                          row_i=1;col_i=2;
                /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,4-row_i,col_i-3,2,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2f");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
        row_i=1;col_i=5;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,4-row_i,col_i-2,2,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2g");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
        row_i=4;col_i=5;
                /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,3-row_i,col_i-2,2,2); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2h");
     my_sprite.tid.tag = sprite_id_name;     
    my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
        row_i=4;col_i=2;
                /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,3-row_i,col_i-3,2,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x2e");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                   }              }
            } else if(i==3)
            {for(k=0;ptr->logic[k]==-3;k++);
              l=k%2;
              for(m=0;m<4 && lookup[m][l]!=ptr->logic[k];m++);
              if(k/2==0)
              {if(l==0 || l==1 && ptr->logic[k]==1)
                {row_i=1;col_i=2+m;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,row_i-1,col_i-2,2,4);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x4");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)TwoWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)FourHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                  } else {
                  row_i=1;col_i=2;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,row_i-1,col_i-3,2,4);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x4b");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)FourHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                 row_i=1;col_i=5;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,row_i-1,col_i-2,2,4);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a2x4c");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)ZeroWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)FourHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                  }
                } else {
                if(l==0 || l==1 && ptr->logic[k]==1)
                {row_i=3-m;col_i=2;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,3-row_i,col_i-2,4,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a4x2");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)FourWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)TwoHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
       free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                  } else {
                  row_i=1;col_i=2;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,row_i-2,col_i-2,4,2);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a4x2b");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)FourWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                  row_i=4;col_i=2;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
		  QuineMcCLogic(memDC,row_i-1,col_i-2,4,2); 
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a4x2c");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)FourWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)ZeroHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
                   }
                }
              }
        }
        ptr=ptr->next;
        }
        }
        }
 if(!strcmp(logicstring,(char *)"") && logictable[4][0]==NULL){
   logicstring=realloc(logicstring,17*sizeof(char));
   strcpy(logicstring,"0 (Always False)");
   } else if(!strcmp(logicstring,(char *)"")){
     logicstring=realloc(logicstring,16*sizeof(char));
   strcpy(logicstring,"1 (Always True)");
   row_i=1;col_i=2;
          /* factorxx=factor0x+factor1x*(double)(col_i-5);factoryy=factor0y+factor1y*(double)(row_i-1);
          factor2x=2.25;factor2y=2.25; */
          QuineMcCLogic(memDC,0,0,4,4);
     /* --- ask how the WIMP is going to scale plot sprite ---
     strcpy(name,"a4x4");
     my_sprite.tid.tag = sprite_id_name;     
     my_sprite.tid.s.name=QuineMcC_strcpy(name);
    wimp_readpixtrans(my_sprite.tarea, &my_sprite.tid, &plotfactors, plottrans);
        regs.r[0]=56+256;
        regs.r[1]=(int)my_sprite.tarea;
        regs.r[2]=(int)name;
        regs.r[3]=1;
        regs.r[4]=0;
        regs.r[5]=15;
        regs.r[6]=(int)QuineMcC_rectangle(240.0*factorxx +(240.0*(1.0-factorxx)+60.0*QuineMcC_fnx(col_i-2))*factorx,(30.0*QuineMcC_fny(row_i-1)+(1.0-factoryy)*100.0)*factory+factoryy*100.0,(int)(factorx*(double)FourWidth*(factor2x-(factor2x-1.0)*factorx)),(int)(factory*(double)FourHeight*(factor2y-(factor2y-1.0)*factory)));
        regs.r[7]=(int)plottrans;
        error=_kernel_swi(OS_SpriteOp,&regs,&regs);
        free(my_sprite.tid.s.name);
        if(error)werr(TRUE,"Plot Error has Occured"); */
   }
 return(logicstring);    
}

PBITMAPINFO CreateBitmapInfoStruct(HWND hwnd, HBITMAP hBmp)
{
    BITMAP bmp;
    WORD    cClrBits;
    // Retrieve the bitmap color format, width, and height.
    if (!GetObject(hBmp, sizeof(BITMAP), (LPSTR)&bmp))
        errhandler("GetObject", hwnd);
    // Convert the color format to a count of bits.
    cClrBits = (WORD)(bmp.bmPlanes * bmp.bmBitsPixel);
    if (cClrBits == 1)
        cClrBits = 1;
    else if (cClrBits <= 4)
        cClrBits = 4;
    else if (cClrBits <= 8)
        cClrBits = 8;
    else if (cClrBits <= 16)
        cClrBits = 16;
    else if (cClrBits <= 24)
        cClrBits = 24;
    else cClrBits = 32;

    // Allocate memory for the BITMAPINFO structure. (This structure
    // contains a BITMAPINFOHEADER structure and an array of RGBQUAD
    // data structures.)

     if (cClrBits != 24)
             pbmi = (PBITMAPINFO) LocalAlloc(LPTR,
                    sizeof(BITMAPINFOHEADER) +
                    sizeof(RGBQUAD) * (1<< cClrBits));

     // There is no RGBQUAD array for the 24-bit-per-pixel format.

             pbmi = (PBITMAPINFO) LocalAlloc(LPTR,
                    sizeof(BITMAPINFOHEADER));

    // Initialize the fields in the BITMAPINFO structure.

    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    pbmi->bmiHeader.biWidth = bmp.bmWidth;
    pbmi->bmiHeader.biHeight = bmp.bmHeight;
    pbmi->bmiHeader.biPlanes = bmp.bmPlanes;
    pbmi->bmiHeader.biBitCount = bmp.bmBitsPixel;
    if (cClrBits < 24)
        pbmi->bmiHeader.biClrUsed = (1<<cClrBits);

    // If the bitmap is not compressed, set the BI_RGB flag.
    pbmi->bmiHeader.biCompression = BI_RGB;

    // Compute the number of bytes in the array of color
    // indices and store the result in biSizeImage.
    // For Windows NT, the width must be DWORD aligned unless
    // the bitmap is RLE compressed. This example shows this.
    // For Windows 95/98/Me, the width must be WORD aligned unless the
    // bitmap is RLE compressed.
    pbmi->bmiHeader.biSizeImage = ((pbmi->bmiHeader.biWidth * cClrBits +31) & ~31) /8
                                  * pbmi->bmiHeader.biHeight;
    // Set biClrImportant to 0, indicating that all of the
    // device colors are important.
     pbmi->bmiHeader.biClrImportant = 0;
     return pbmi;
 }

void CreateBMPFile(HWND hwnd, LPTSTR pszFile, PBITMAPINFO pbi,
                  HBITMAP hBMP, HDC hDC)
 {
     HANDLE hf;                 // file handle
    BITMAPFILEHEADER hdr;       // bitmap file-header
    PBITMAPINFOHEADER pbih;     // bitmap info-header
    LPBYTE lpBits;              // memory pointer
    DWORD dwTotal;              // total count of bytes
    DWORD cb;                   // incremental count of bytes
    BYTE *hp;                   // byte pointer
    DWORD dwTmp;

    pbih = (PBITMAPINFOHEADER) pbi;
    lpBits = (LPBYTE) GlobalAlloc(GMEM_FIXED, pbih->biSizeImage);

    if (!lpBits)
         errhandler("GlobalAlloc", hwnd);

    // Retrieve the color table (RGBQUAD array) and the bits
    // (array of palette indices) from the DIB.
    if (!GetDIBits(hDC, hBMP, 0, (WORD) pbih->biHeight, lpBits, pbi,
        DIB_RGB_COLORS))
    {
        errhandler("GetDIBits", hwnd);
    }

    // Create the .BMP file.
    hf = CreateFile(pszFile,
                   GENERIC_READ | GENERIC_WRITE,
                   (DWORD) 0,
                    NULL,
                   CREATE_ALWAYS,
                   FILE_ATTRIBUTE_NORMAL,
                   (HANDLE) NULL);
    if (hf == INVALID_HANDLE_VALUE)
        errhandler("CreateFile", hwnd);
    hdr.bfType = 0x4d42;        // 0x42 = "B" 0x4d = "M"
    // Compute the size of the entire file.
    hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) +
                 pbih->biSize + pbih->biClrUsed
                 * sizeof(RGBQUAD) + pbih->biSizeImage);
    hdr.bfReserved1 = 0;
    hdr.bfReserved2 = 0;

    // Compute the offset to the array of color indices.
    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) +
                    pbih->biSize + pbih->biClrUsed
                    * sizeof (RGBQUAD);

    // Copy the BITMAPFILEHEADER into the .BMP file.
    if (!WriteFile(hf, (LPVOID) &hdr, sizeof(BITMAPFILEHEADER),
        (LPDWORD) &dwTmp,  NULL))
    {
       errhandler("WriteFile", hwnd);
    }

    // Copy the BITMAPINFOHEADER and RGBQUAD array into the file.
    if (!WriteFile(hf, (LPVOID) pbih, sizeof(BITMAPINFOHEADER)
                  + (pbih->biClrUsed) * sizeof (RGBQUAD),
                  (LPDWORD) &dwTmp, NULL))
        errhandler("WriteFile", hwnd);

    // Copy the array of color indices into the .BMP file.
    dwTotal = cb = pbih->biSizeImage;
    hp = lpBits;
    if (!WriteFile(hf, (LPSTR) hp, (int) cb, (LPDWORD) &dwTmp,NULL))
           errhandler("WriteFile", hwnd);

    // Close the .BMP file.
     if (!CloseHandle(hf))
           errhandler("CloseHandle", hwnd);

    // Free memory.
    GlobalFree((HGLOBAL)lpBits);
}

void DoSelectFont(HWND hwnd)
{
	CHOOSEFONT cf = {sizeof(CHOOSEFONT)};
	LOGFONT lf;

	GetObject(g_hfFont, sizeof(LOGFONT), &lf);

	cf.Flags = CF_EFFECTS | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
	cf.hwndOwner = hwnd;
	cf.lpLogFont = &lf;
	cf.rgbColors = g_rgbText;

	if(ChooseFont(&cf))
	{
		HFONT hf = CreateFontIndirect(&lf);
		if(hf)
		{
			g_hfFont = hf;
		}
		else
		{
			MessageBox(hwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
		}

		g_rgbText = cf.rgbColors;
	}
}

void DoSelectColour(HWND hwnd)
{
	CHOOSECOLOR cc = {sizeof(CHOOSECOLOR)};

	cc.Flags = CC_RGBINIT | CC_FULLOPEN | CC_ANYCOLOR;
	cc.hwndOwner = hwnd;
	cc.rgbResult = g_rgbBackground;
	cc.lpCustColors = g_rgbCustom;

	if(ChooseColor(&cc))
	{
		g_rgbBackground = cc.rgbResult;
	}
}

void DrawClientSize(HDC hdc, RECT* prc, HFONT hf, double vpos, HWND hwnd)
{static int i,j,k,linecount;
    char message[300];
	char *szTitle;
static char szBlank[7001];
SIZE size;
SCROLLINFO si;
HDC HD;
	char *szLine[7] ={"\x0d\n  \xa9 Martin Carradus, Leaf Mindcraft 2010\x0d\n \x0d\n  QuineMcC\x0d\n  ~~~~~~~\x0d\n  \x0d\n  Purpose: To use the Quine-McCluskey Method (Algorithm) to Simplify a Logical Function.\x0d\n",
    "  \x0d\n  Input: Karnaugh Map giving the Logical Function required.\x0d\n  \x0d\n  Output: Optimised Canonical Boolean Expression for the Function.\x0d\n  \x0d\n",
   "------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\x0d\n",
   " Select From \'K Map\' Window to Supply Logical Values in the Cells (They Toggle 0 (False) or 1 (True), by Mouse Clicks).\x0d\n\x0d\n",
   " Then Click \'Run QuineMcC\', and the Optimised Logical Expression will appear in a Window\x0d\n\x0d\n",
   " Select \'Help\', or Press F1 for Help Information.\x0d\n",
   "------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n"};
      HFONT hfOld = (HFONT)SelectObject(hdc, hf);
    if(!Opened){
	SetBkColor(hdc, g_rgbBackground);
	SetTextColor(hdc, g_rgbText);

	if(g_bOpaque)
	{
		SetBkMode(hdc, OPAQUE);
	}
	else
	{
		SetBkMode(hdc, TRANSPARENT);
	}
GetTextMetrics(hdc,&tm);
DY=tm.tmHeight+tm.tmExternalLeading;	
if(!SetUp && !Done && (!Opened || Descript || Opened && !Run)){
 /* Update Vertical Bar Position */
		si.cbSize=sizeof(SCROLLINFO);
		si.nMin=0;
		si.nMax=VERTRANGEMAX;
		si.fMask=SIF_POS;
		si.nPos=0;
		SetScrollInfo(hwnd,SB_VERT,&si,TRUE);
        Done=TRUE;
        };
    if(Descript){
    sprintf(message,szformat,VSN,MYDATE);
    if(description)szInfoLine[0]=(char *)malloc((strlen(message)+1)*sizeof(char));
    description=FALSE;
    strcpy(szInfoLine[0],message);
        i=1;
    i+=strlen(szInfoLine[0]);
    szTitle=(char *)malloc(i*sizeof(char));
    strcpy(szTitle,szInfoLine[0]);
    for(j=1;j<3;j++){
        i+=strlen(szInfoLine[j]);
        szTitle=(char *)realloc(szTitle,i*sizeof(char));
        strcat(szTitle,szInfoLine[j]);
    };
    } else {
    i=1;
    i+=strlen(szLine[0]);
    szTitle=(char *)malloc(i*sizeof(char));
    strcpy(szTitle,szLine[0]);
    for(j=1;j<7;j++){
        i+=strlen(szLine[j]);
        szTitle=(char *)realloc(szTitle,i*sizeof(char));
        strcat(szTitle,szLine[j]);
    };
      }
    i=0;
    for(j=0;j<vpos;j++){
    for(;szTitle[i]!='\n';i++);
    i++;
    }
    linecount=1;
    for(j=i;szTitle[j+1]!='\0' && linecount<36;j++)if(szTitle[j]=='\n')linecount++;
    szTitle[j+1]='\0';
    k=0;
    for(linecount=1;linecount<36;linecount++){
    for(;k<(linecount-1)*150+148;k++)szBlank[k]=' ';
    szBlank[k++]='\r';
    szBlank[k++]='\n';
    };
    szBlank[k]='\0';
    DrawText(hdc,szBlank,k+1,prc,DT_WORDBREAK);
	DrawText(hdc,&(szTitle[i]),j-i+1, prc, DT_WORDBREAK);

 	  } else {
 	BitBlt(hdc,0,0,maxX,maxY,memDC3,0,0,SRCCOPY);
         }
	SelectObject(hdc, hfOld);
}


void DoSelectProgFont(HWND hwnd)
{
	CHOOSEFONT cf = {sizeof(CHOOSEFONT)};
	LOGFONT lf;

	GetObject(g_hfprogFont, sizeof(LOGFONT), &lf);

	cf.Flags = CF_EFFECTS | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
	cf.hwndOwner = hwnd;
	cf.lpLogFont = &lf;
	cf.rgbColors = g_rgbprogText;

	if(ChooseFont(&cf))
	{
		HFONT hf = CreateFontIndirect(&lf);
		if(hf)
		{
			g_hfprogFont = hf;
		}
		else
		{
			MessageBox(hwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
		}

		g_rgbprogText = cf.rgbColors;
	}
}

void DoSelectProgColour(HWND hwnd)
{
	CHOOSECOLOR cc = {sizeof(CHOOSECOLOR)};

	cc.Flags = CC_RGBINIT | CC_FULLOPEN | CC_ANYCOLOR;
	cc.hwndOwner = hwnd;
	cc.rgbResult = g_rgbprogBackground;
	cc.lpCustColors = g_rgbprogCustom;

	if(ChooseColor(&cc))
	{
		g_rgbprogBackground = cc.rgbResult;
	}
}
void DoSelectHelpFont(HWND hwnd)
{
	CHOOSEFONT cf = {sizeof(CHOOSEFONT)};
	LOGFONT lf;

	GetObject(g_hfhelpFont, sizeof(LOGFONT), &lf);

	cf.Flags = CF_EFFECTS | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
	cf.hwndOwner = hwnd;
	cf.lpLogFont = &lf;
	cf.rgbColors = g_rgbhelpText;

	if(ChooseFont(&cf))
	{
		HFONT hf = CreateFontIndirect(&lf);
		if(hf)
		{
			g_hfhelpFont = hf;
		}
		else
		{
			MessageBox(hwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
		}

		g_rgbhelpText = cf.rgbColors;
	}
}

void DoSelectHelpColour(HWND hwnd)
{
	CHOOSECOLOR cc = {sizeof(CHOOSECOLOR)};

	cc.Flags = CC_RGBINIT | CC_FULLOPEN | CC_ANYCOLOR;
	cc.hwndOwner = hwnd;
	cc.rgbResult = g_rgbhelpBackground;
	cc.lpCustColors = g_rgbhelpCustom;

	if(ChooseColor(&cc))
	{
		g_rgbhelpBackground = cc.rgbResult;
	}
}

void DoSelectLogicFont(HWND hwnd)
{
	CHOOSEFONT cf = {sizeof(CHOOSEFONT)};
	LOGFONT lf;

	GetObject(g_hfLogicFont, sizeof(LOGFONT), &lf);

	cf.Flags = CF_EFFECTS | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
	cf.hwndOwner = hwnd;
	cf.lpLogFont = &lf;
	cf.rgbColors = g_rgbLogicText;

	if(ChooseFont(&cf))
	{
		HFONT hf = CreateFontIndirect(&lf);
		if(hf)
		{
			g_hfLogicFont = hf;
		}
		else
		{
			MessageBox(hwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
		}

		g_rgbLogicText = cf.rgbColors;
	}
}

void DoSelectLogicColour(HWND hwnd)
{
	CHOOSECOLOR cc = {sizeof(CHOOSECOLOR)};

	cc.Flags = CC_RGBINIT | CC_FULLOPEN | CC_ANYCOLOR;
	cc.hwndOwner = hwnd;
	cc.rgbResult = g_rgbLogicBackground;
	cc.lpCustColors = g_rgbLogicCustom;

	if(ChooseColor(&cc))
	{
		g_rgbLogicBackground = cc.rgbResult;
	}
}

void DrawHelpClientSize(HDC hdc, RECT* prc, HFONT hf, double vpos)
{int i,j,k,linecount;
	char *szTitle;
	char szBlank[7001];
	char *szLine[17] ={"\x0d\n  \xa9 Martin Carradus, Leaf Mindcraft 2010\x0d\n \x0d\n  QuineMcC\x0d\n  ~~~~~~~\x0d\n  \x0d\n  Purpose: To use the Quine-McCluskey Algorithm on a Karnaugh Map.\x0d\n  \x0d\n  Input: Initial 'K Map' Function giving 0 (False) and 1 (True) for each logical state of the A, B, C and D.\x0d\n  \x0d\n  Output: A Window giving the Optimised Canonical Boolean Expression for the supplied Function.\x0d\n  \x0d\n \x0d\n  Menu Item                        Action/Meaning                                        Default          ShortCut\x0d\n  -----------------                 ----------------------------------------                                ------------          -------------\x0d\n",
    " QuineMcC: New      Starts QuineMcC from Beginning Again             Disenabled        Ctrl+N\x0d\n",
    "                    Exit      Aborts Application                                               Enabled            Alt+F4\x0d\n",
    "------------------------------------------------------------------------------------------------------------------------------------------------\x0d\n",
    "\x0d\n         Show K Map:      Displays Karnaugh Map for editing                  Enabled         Ctrl+K\x0d\n",
    "\x0d\n         Description:       Supplies Description of this QuineMcC Application    Off         Ctrl+D\x0d\n",
    "\x0d\n         Run QuineMcC:  Runs QuineMcC with Current Karnaugh Map          Off           F5\x0d\n",
    "\x0d\n         Help:                 Supplies This Help Information                                  Off           F1\x0d\n",
    "------------------------------------------------------------------------------------------------------------------------------------------------\x0d\n",
    " Karnaugh: Reset      Sets Karnaugh Map from to all Zero (False)          Enabled            Ctrl+R\x0d\n",
    "                  Hide        Removes Karnaugh Window                                Enabled            Ctrl+H\x0d\n",
    "------------------------------------------------------------------------------------------------------------------------------------------------\x0d\n",
    "\x0d\n         Save Karnaugh As:      Saves Karnaugh Map as BMP image       Enabled            Ctrl+S\x0d\n",
    "\x0d\n         Print Karnaugh:            Sends Map to Printer                                Enabled            Ctrl+P\x0d\n",
    "------------------------------------------------------------------------------------------------------------------------------------------------\x0d\n",
    " \'Save As\' and \'Print\' Opions are also available from the Logical Expression Display Window menu.                                                       \x0d\n",
    "N.B. You can ONLY choose \'Run QuineMcC\' once the Karnaugh Map has been Altered in some way.\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n\x0d\n"};
    HFONT hfOld = (HFONT)SelectObject(hdc, hf);

	SetBkColor(hdc, g_rgbhelpBackground);
	SetTextColor(hdc, g_rgbhelpText);

	if(g_bhelpOpaque)
	{
		SetBkMode(hdc, OPAQUE);
	}
	else
	{
		SetBkMode(hdc, TRANSPARENT);
	}
    i=1;
    i+=strlen(szLine[0]);
    szTitle=(char *)malloc(i*sizeof(char));
    strcpy(szTitle,szLine[0]);
    for(j=1;j<17;j++){
        i+=strlen(szLine[j]);
        szTitle=(char *)realloc(szTitle,i*sizeof(char));
        strcat(szTitle,szLine[j]);
    };
    k=0;
    for(linecount=1;linecount<36;linecount++){
    for(;k<(linecount-1)*150+148;k++)szBlank[k]=' ';
    szBlank[k++]='\r';
    szBlank[k++]='\n';
    };
    szBlank[k]='\0';
    DrawText(hdc,szBlank,k+1,prc,DT_WORDBREAK);
	DrawText(hdc,szTitle,i+1, prc, DT_WORDBREAK);
	free(szTitle);
	SelectObject(hdc, hfOld);
}

void DrawLogicClientSize(HDC hdc, RECT* prc, HFONT hf, double vpos)
{    HFONT hfOld = (HFONT)SelectObject(hdc, hf);

	if(g_blogicOpaque)
	{
		SetBkMode(hdc, OPAQUE);
	}
	else
	{
		SetBkMode(hdc, TRANSPARENT);
	}
 
	SelectObject(hdc, hfOld);
}

int WINAPI
WinMain (HINSTANCE hThisInstance,
         HINSTANCE hPrevInstance,
         LPSTR lpszArgument,
         int nFunsterStil)

{
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */
    WNDCLASSEX helpwincl;        /* Data structure for the help window class */
    WNDCLASSEX progwincl;        /* Data structure for the progress window class */
    WNDCLASSEX karnaughwincl;        /* Data structure for the karnaugh window class */
    WNDCLASSEX logicwincl;        /* Data structure for the logic window class */
     HMENU hMenu;
    HMENU hSubMenu;
    maxX=GetSystemMetrics(SM_CXSCREEN);
    maxY=GetSystemMetrics(SM_CYSCREEN);
        /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (hThisInstance, "MyIcon");
    wincl.hIconSm = NULL;
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = "MyMenu";                 /* Has menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's white as the background of the window */
    wincl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
    hInst=hThisInstance;
    /* Register the window class, and if it fails quit the program */

           if (!RegisterClassEx (&wincl))
        return 0;
    /* The class is registered, let's create the program*/
    mainwind=hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "QuineMcC - Quine McCluskey Logic Optimisation of Karnaugh Map.",       /* Title Text */
           WS_OVERLAPPEDWINDOW | WS_VSCROLL | WS_HSCROLL, /* default window */
           0,       /* Windows decides the position */
           0,       /* where the window ends up on the screen */
           maxX,                 /* The programs width */
           maxY-25,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );
    /* For Help Window */
           /* The WNDCLASSEX structure */
    helpwincl.hInstance = hThisInstance;
    helpwincl.lpszClassName = szHelpClassName;
    helpwincl.lpfnWndProc = WndProc;      /* This function is called by windows */
    helpwincl.style = 0;                 /* Default Style */
    helpwincl.cbSize = sizeof(WNDCLASSEX);
    helpwincl.hIcon = LoadIcon(hThisInstance, "MyIcon");
    helpwincl.hIconSm = NULL;
    helpwincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    helpwincl.lpszMenuName = NULL; /* No menu */
    helpwincl.cbClsExtra = 0;
    helpwincl.cbWndExtra = 0;
    helpwincl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&helpwincl))return(0);


    /* The class is registered, create the window*/
    helpwind = CreateWindowEx(
           0,
           szHelpClassName,
           "QuineMcC Help Window - This Will Only Display Once",
           WS_OVERLAPPEDWINDOW,
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           500,
           550,
           HWND_DESKTOP,
           NULL,
           hThisInstance,
           NULL
           );
      if(helpwind == NULL)
	  {
		MessageBox(NULL, "Help Window Creation Failed!", "Error from QuineMcC",
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	   }
	
       helpFunsterStil=nFunsterStil;
       hhelpInst=hThisInstance;
    karnaughwincl.hInstance = hThisInstance;
    karnaughwincl.lpszClassName = szKarnaughClassName;
    karnaughwincl.lpfnWndProc = DialogFunc4;      /* This function is called by windows */
    karnaughwincl.style = 0;                 /* Default Style */
    karnaughwincl.cbSize = sizeof(WNDCLASSEX);
    karnaughwincl.hIcon = LoadIcon (hThisInstance, "MyIcon");
    karnaughwincl.hIconSm = NULL;
    karnaughwincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    karnaughwincl.lpszMenuName = "MyKarnaugh";
    karnaughwincl.cbClsExtra = 0;
    karnaughwincl.cbWndExtra = 0;
    karnaughwincl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&karnaughwincl))return(0);
       karnaughFunsterStil=nFunsterStil;
       hkarnaughInst=hThisInstance;
           /* The WNDCLASSEX structure */
    logicwincl.hInstance = hThisInstance;
    logicwincl.lpszClassName = szLogicClassName;
    logicwincl.lpfnWndProc = WndProc4;      /* This function is called by windows */
    logicwincl.style = 0;                 /* Default Style */
    logicwincl.cbSize = sizeof(WNDCLASSEX);
    logicwincl.hIcon = LoadIcon(hThisInstance, "MyIcon");
    logicwincl.hIconSm = NULL;
    logicwincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    logicwincl.lpszMenuName = "MyLogic"; /* menu */
    logicwincl.cbClsExtra = 0;
    logicwincl.cbWndExtra = 0;
    logicwincl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&logicwincl))return(0);
	
       logicFunsterStil=nFunsterStil;
       hlogicInst=hThisInstance;
    if(MessageBox(hwnd,"DISCLAIMER - AGREEMENT \"QuineMcC is supplied as is. The author disclaims all warranties, expressed or implied, including, without limitation, the warranties of merchantability and of fitness for any purpose. The author assumes no liability for damages, direct or consequential, which may result from the use of QuineMcC.\"","Message from QuineMcC",MB_OKCANCEL)==IDOK)
	    {
    hAccel = LoadAccelerators(hThisInstance, "MyMenu");
       hMenu=GetMenu(hwnd);
    hSubMenu=GetSubMenu(hMenu,0);
    EnableMenuItem(hSubMenu,IDM_RESET,MF_BYCOMMAND | MF_GRAYED);
    hSubMenu=GetSubMenu(hMenu,1);
    EnableMenuItem(hSubMenu,IDM_ISAVE,MF_BYCOMMAND | MF_GRAYED);
    EnableMenuItem(hSubMenu,IDM_IPRINT,MF_BYCOMMAND | MF_GRAYED);
    EnableMenuItem(hMenu,IDM_RUNQUINE,MF_BYCOMMAND | MF_GRAYED);
    DrawMenuBar(hwnd);
        /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);
    keycode=0;
    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        if(!TranslateAccelerator(hwnd, hAccel, &messages)){
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
          }
         }
       } else {
            DestroyWindow(hwnd);
            return(0);
          }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}

/* This function is called by the Windows function DispatchMessage( ) */
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
 static long lfHeight;
 static SCROLLINFO si;
 static int vpos;
 static RECT rcClient;
 static PAINTSTRUCT ps;
 static HDC hdc;
 static HFONT hf;
 	switch(msg)
	{
	    case WM_INITDIALOG:
	    vpos=0.0;
	    si.cbSize=sizeof(SCROLLINFO);
	    si.fMask=SIF_RANGE;
	    si.nMin=0;si.nMax=VERTRANGEMAX;
	    SetScrollInfo(hwnd,SB_VERT,&si,TRUE);
	    if(Karnaugh)SetFocus(karnaughwind);
	    if(Logic)SetFocus(logicwind);
	    break;
		case WM_CREATE:
			g_hfhelpFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
		break;
		case WM_CHAR:
		if(Accept)keycode=(char)wParam;
		break;
		case WM_CLOSE:
		    Help=FALSE;
		    DeleteObject(g_hfhelpFont);
		    DestroyWindow(hwnd);
			PostQuitMessage(0);
		break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case ID_FILE_EXIT:
				    DestroyWindow(hwnd);
					PostMessage(hwnd, WM_CLOSE, 0, 0);
				break;
				case ID_FORMAT_FONT:
					DoSelectHelpFont(hwnd);

					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;
				case ID_FORMAT_DEFAULTGUIFONT:
					DeleteObject(g_hfhelpFont);
					g_hfhelpFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
					
					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;
				case ID_FORMAT_TEST:
				{   HDC hdc;
				    HFONT hf;
					
					hdc = GetDC(NULL);
					lfHeight = -MulDiv(12, GetDeviceCaps(hdc, LOGPIXELSY), 72);
					ReleaseDC(NULL, hdc);

					hf = CreateFont(lfHeight, 0, 0, 0, 0, TRUE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");

					if(hf)
					{
						DeleteObject(g_hfhelpFont);
						g_hfhelpFont = hf;
					}
					else
					{
						MessageBox(hwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
					}					
					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				}
				break;
				case ID_FORMAT_BACKGROUNDCOLOUR:
					DoSelectHelpColour(hwnd);

					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;
				case ID_FORMAT_OPAQUE:
					g_bhelpOpaque = !g_bhelpOpaque;

					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;
			}
		break;
		case WM_INITMENUPOPUP:
			CheckMenuItem((HMENU)wParam, ID_FORMAT_OPAQUE, MF_BYCOMMAND | ( g_bOpaque ? MF_CHECKED : MF_UNCHECKED));
		break;
		
		case WM_PAINT:
		{
			
			hdc = BeginPaint(hwnd, &ps);

			GetClientRect(hwnd, &rcClient);

			DrawHelpClientSize(hdc, &rcClient, g_hfFont, vpos);

			EndPaint(hwnd, &ps);
		}
		break;
		
		case WM_VSCROLL:
		switch(LOWORD(wParam)){
		  case SB_TOP:
		  vpos=0.0;
		  break;
		
		  case SB_BOTTOM:
		  vpos=(double)VERTRANGEMAX;
		  break;
		
		  case SB_LINEDOWN:
		  vpos++;
		  if(vpos>VERTRANGEMAX)vpos=(double)VERTRANGEMAX;
		  break;
		
		  case SB_LINEUP:
		  vpos--;
		  if(vpos<0)vpos=0.0;
		  break;
		
		  case SB_THUMBPOSITION:
		  vpos=(double)HIWORD(wParam); /* Get current position */
		  break;
		
		  case SB_THUMBTRACK:
		  vpos=(double)HIWORD(wParam); /* Get current position */
		  break;
		
		  case SB_PAGEDOWN:
		  vpos+=20.0;
		  if(vpos>VERTRANGEMAX)vpos=(double)VERTRANGEMAX;
		  break;
		
		  case SB_PAGEUP:
		  vpos-=20.0;
		  if(vpos<0)vpos=0.0;
		  break;
		      }
		/* Update Vertical Bar Position */
		si.cbSize=sizeof(SCROLLINFO);
		si.nMin=0;
		si.nMax=VERTRANGEMAX;
		si.fMask=SIF_POS;
		si.nPos=(int)vpos;
		SetScrollInfo(hwnd,SB_VERT,&si,TRUE);
		hdc=GetDC(hwnd);
		GetClientRect(hwnd, &rcClient);
        DrawHelpClientSize(hdc, &rcClient, g_hfhelpFont, vpos);
        ReleaseDC(hwnd,hdc);
		/* Scroll Text */
		/* ScrollWindow(hwnd,0,-lfHeight*vpos,
		(CONST RECT *) NULL, (CONST RECT *)NULL); */
		UpdateWindow(hwnd);
		break;
		
		case WM_QUIT:
		break;
		
		case WM_DESTROY:
			DeleteObject(g_hfhelpFont);
			PostQuitMessage(0);
		break;
		
		default:
			return DefWindowProc(hwnd, msg, wParam, lParam);
	}
	return 0;
}

/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK
WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{OPENFILENAME ofn;
 static long lfHeight;
 static double Oldvpos;
 static SCROLLINFO si;
 static RECT rcClient;
 static PAINTSTRUCT ps;
 static char szFileName[MAXFILENAME]= "";
 static HDC memDC, memPrDC;
 static HDC hdc;
 static HBRUSH hBrush;
 static HMENU hMenu;
 static HMENU hSubMenu;
 static char mess[300], szLeaf[41];
 static int lines=0,copies,YY,line=5,X,i;
 static PRINTDLG printdlg;
 static DOCINFO docinfo;
 static char pLine[81];
 static int ii,jj;
     switch (message)                  /* handle the messages */
    {   case WM_CREATE:
		    maxX=GetSystemMetrics(SM_CXSCREEN);
		    maxY=GetSystemMetrics(SM_CYSCREEN);
		    Width_1=x-1;Height_1=y-1;
			g_hfFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
			    /* create a virtual window */
			hdc=GetDC(hwnd);
			memDC3=CreateCompatibleDC(hdc);
			hbit=CreateCompatibleBitmap(hdc,maxX,maxY);
			SelectObject(memDC3,hbit);
			hBrush=(HBRUSH)GetStockObject(WHITE_BRUSH);
			SelectObject(memDC3,hBrush);
			PatBlt(memDC3,0,0,maxX,maxY,PATCOPY);
			ReleaseDC(hwnd,hdc);
		break;
		case WM_CHAR:
		if(Accept)keycode=(char)wParam;
		break;
        case WM_COMMAND:
        if(Help)SetFocus(helpwind);
        if(Karnaugh)SetFocus(karnaughwind);
			switch(LOWORD(wParam))
			{
            case IDM_RESET:
            if(Karnaugh)DestroyWindow(karnaughwind);
		    if(Help)DestroyWindow(helpwind);
		    if(Logic)DestroyWindow(logicwind);
		    Logic=FALSE;
            Opened=FALSE;initialised=FALSE;Next=FALSE;Closed=FALSE;
            Descript=FALSE;SetUp=FALSE;Karnaugh=FALSE;Finished=FALSE;
           Run=FALSE;Start=TRUE;KarnaughSetUp=FALSE;Help=FALSE;
            hMenu=GetMenu(hwnd);
    hSubMenu=GetSubMenu(hMenu,0);
    EnableMenuItem(hSubMenu,IDM_RESET,MF_BYCOMMAND | MF_GRAYED);
    EnableMenuItem(hMenu,IDM_GSHOW,MF_BYCOMMAND | MF_ENABLED);
    EnableMenuItem(hMenu,IDM_DESCRIPTION,MF_BYCOMMAND | MF_ENABLED);
    EnableMenuItem(hMenu,IDM_RUNQUINE,MF_BYCOMMAND | MF_GRAYED);
    DrawMenuBar(hwnd);
    hBrush=(HBRUSH)GetStockObject(WHITE_BRUSH);
	SelectObject(memDC3,hBrush);
	PatBlt(memDC3,0,0,maxX,maxY,PATCOPY);
    InvalidateRect(hwnd, NULL, TRUE);
    for(jj=0;jj<4;jj++)for(ii=0;ii<4;ii++){KarnaughMap[jj][ii]=0;B[ii][jj]=0;}
    for(jj=0;jj<5;jj++)for(ii=0;ii<5;ii++){ptr=logictable[jj][ii];
    while(ptr!=NULL && ptr!=(logicrec *)EOF){ptrnext=ptr->next;free(ptr->logic);free(ptr);ptr=ptrnext;};
	logictable[jj][ii]=NULL;logicrecount[jj][ii]=0;}
			break;
 			case IDM_EXIT:
 		  if(Logic)DestroyWindow(logicwind);
		  Logic=FALSE; 	
          if(Help)DestroyWindow(helpwind);
          if(Karnaugh)DestroyWindow(karnaughwind);
			PostQuitMessage(0);
			exit(0);
			break;
			case IDM_GSHOW:
			if(Help)SetFocus(helpwind);
			Karnaugh=TRUE;
			KarnaughSetUp=FALSE;
			hMenu=GetMenu(hwnd);
			EnableMenuItem(hMenu,IDM_GSHOW,MF_BYCOMMAND | MF_GRAYED);
			karnaughwind = CreateWindowEx(
           0,
           szKarnaughClassName,
           "Karnaugh Map - Click on Squares to Toggle Value",
           WS_OVERLAPPEDWINDOW,
           maxX-500,
           20,
           450,
           490,
           HWND_DESKTOP,
           NULL,
           hkarnaughInst,
           NULL
           );
      if(karnaughwind == NULL)
	  {
		MessageBox(hwnd, "Karnaugh Map Window Creation Failed!", "Error from QuineMcC",
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	   }
    hKarnaughAccel = LoadAccelerators(hkarnaughInst, "MyKarnaugh");   		
			    /* Make the window visible on the screen */		
    ShowWindow (karnaughwind, karnaughFunsterStil);
    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&karnaughmessages, NULL, 0, 0))
    {
        if(!TranslateAccelerator(hwnd, hKarnaughAccel, &karnaughmessages)){
        TranslateMessage(&karnaughmessages);
        /* Send message to WindowProcedure */
        DispatchMessage(&karnaughmessages);
          };

         };
         DestroyWindow(karnaughwind);
			break;
			case IDM_GHIDE:
			Karnaugh=FALSE;
			hMenu=GetMenu(hwnd);
			hSubMenu=GetSubMenu(hMenu,2);
			EnableMenuItem(hMenu,IDM_GSHOW,MF_BYCOMMAND | MF_ENABLED);
			EnableMenuItem(hMenu,IDM_GHIDE,MF_BYCOMMAND | MF_GRAYED);
			SendMessage(karnaughwind,WM_CLOSE,0,0);
			break;
			case IDM_DESCRIPTION:
			if(!Descript){Descript=TRUE;description=TRUE;
                InvalidateRect(hwnd,NULL,1);
                  };
			break;
			case IDM_RUNQUINE:
			if(Karnaugh)SetFocus(karnaughwind);
			if(Help)SetFocus(helpwind);
			hMenu=GetMenu(hwnd);
	EnableMenuItem(hMenu,IDM_RUNQUINE,MF_BYCOMMAND | MF_GRAYED);
	hSubMenu=GetSubMenu(hMenu,0);
    EnableMenuItem(hSubMenu,IDM_RESET,MF_BYCOMMAND | MF_ENABLED);
    		/* hSubMenu=GetSubMenu(hMenu,1);
    EnableMenuItem(hSubMenu,IDM_ISAVE,MF_BYCOMMAND | MF_ENABLED);
    EnableMenuItem(hSubMenu,IDM_IPRINT,MF_BYCOMMAND | MF_ENABLED);*/
    DrawMenuBar(hwnd);
			loop_count_i=0;keycode=0;
			logicstring=QMcCprocess(memDC4);
			Finished=TRUE;
			InvalidateRect(karnaughwind,NULL,TRUE);
			SetFocus(karnaughwind);
			hMenu=GetMenu(hwnd);
	EnableMenuItem(hMenu,IDM_GSHOW,MF_BYCOMMAND | MF_GRAYED);
   /* The class is registered, create the window*/
    logicwind = CreateWindowEx(
           0,
           szLogicClassName,
           "QuineMcC Logic Window - Optimised Canonical Boolean Expression for Karnaugh Map",
           WS_OVERLAPPEDWINDOW,
           0,
           600,
           maxX,
           85,
           HWND_DESKTOP,
           NULL,
           hlogicInst,
           NULL
           );
      if(logicwind == NULL)
	  {
		MessageBox(NULL, "Logic Window Creation Failed!", "Error from QuineMcC",
			MB_ICONEXCLAMATION | MB_OK);
		return 0;
	   }
 			   Logic=TRUE;
    hLogicAccel = LoadAccelerators(hlogicInst, "MyLogic"); 			   
			   ShowWindow(logicwind, logicFunsterStil);
    /* Run the message loop. It will run until GetMessage( ) returns 0 */
    while(GetMessage(&logicmessages, NULL, 0, 0))
    {
      if(!TranslateAccelerator(hwnd, hLogicAccel, &logicmessages)){
           TranslateMessage(&logicmessages);
           DispatchMessage(&logicmessages);
         }
      };
			break;
			case IDM_HELP:
			if(Karnaugh)SetFocus(karnaughwind);
			Help=TRUE;hMenu=GetMenu(hwnd);
    EnableMenuItem(hMenu,IDM_HELP,MF_BYCOMMAND | MF_GRAYED);
    DrawMenuBar(hwnd);
   // DialogBox(hThisInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, Main_Proc);
    ShowWindow(helpwind, helpFunsterStil);
    /* Run the message loop. It will run until GetMessage( ) returns 0 */
    while(GetMessage(&helpmessages, NULL, 0, 0))
    {
           TranslateMessage(&helpmessages);
           DispatchMessage(&helpmessages);
      };
      /* DestroyWindow(helpwind); */
			break;
			         }
		break;
        case ID_FILE_EXIT:
					PostMessage(hwnd, WM_CLOSE, 0, 0);
				break;

				case ID_FORMAT_FONT:
					DoSelectFont(hwnd);

					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;
				case ID_FORMAT_DEFAULTGUIFONT:
					DeleteObject(g_hfFont);
					g_hfFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
					
					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;
				case ID_FORMAT_TEST:
				{
					HFONT hf;
					HDC hdc;
					
					hdc = GetDC(NULL);
					lfHeight = -MulDiv(12, GetDeviceCaps(hdc, LOGPIXELSY), 72);
					ReleaseDC(NULL, hdc);

					hf = CreateFont(lfHeight, 0, 0, 0, 0, TRUE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");

					if(hf)
					{
						DeleteObject(g_hfFont);
						g_hfFont = hf;
					}
					else
					{
						MessageBox(hwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
					}					
					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				}
				break;
				case ID_FORMAT_BACKGROUNDCOLOUR:
					DoSelectColour(hwnd);

					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;
				case ID_FORMAT_OPAQUE:
					g_bOpaque = !g_bOpaque;

					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);
				break;

		case WM_INITMENUPOPUP:
			CheckMenuItem((HMENU)wParam, ID_FORMAT_OPAQUE, MF_BYCOMMAND | ( g_bOpaque ? MF_CHECKED : MF_UNCHECKED));
		break;
		
		case WM_PAINT:
		{
			
			painthdc = BeginPaint(hwnd, &ps);

			GetClientRect(hwnd, &rcClient);

            if(!SetUp)
			DrawClientSize(painthdc, &rcClient, g_hfFont, vpos, hwnd);
			
			else
			
			BitBlt(painthdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right-ps.rcPaint.left,ps.rcPaint.bottom-ps.rcPaint.top,memDC3,ps.rcPaint.left+(int)HPos,ps.rcPaint.top+(int)VPos,SRCCOPY);


			EndPaint(hwnd, &ps);
		}
		break;
		
		case WM_VSCROLL:
		switch(LOWORD(wParam)){
		  case SB_TOP:
		  vpos=0.0;
		  break;
		
		  case SB_BOTTOM:
		  vpos=(double)height;
		  break;
		
		  case SB_LINEDOWN:
		  vpos++;
		  if(vpos>height)vpos=(double)height;
		  break;
		
		  case SB_LINEUP:
		  vpos--;
		  if(vpos<0)vpos=0.0;
		  break;
		
		  case SB_THUMBPOSITION:
		  vpos=(double)HIWORD(wParam); /* Get current position */
		  break;
		
		  case SB_THUMBTRACK:
		  vpos=(double)HIWORD(wParam); /* Get current position */
		  break;
		
		  case SB_PAGEDOWN:
		  vpos+=20.0;
		  if(vpos>height)vpos=(double)height;
		  break;
		
		  case SB_PAGEUP:
		  vpos-=20.0;
		  if(vpos<0)vpos=0.0;
		  break;
		      }
		/* Update Vertical Bar Position */
		if(vpos!=Oldvpos){
		Oldvpos=vpos;
		si.cbSize=sizeof(SCROLLINFO);
		si.nMin=0;
		si.nMax=height;
		si.fMask=SIF_POS;
		si.nPos=(int)vpos;
		SetScrollInfo(hwnd,SB_VERT,&si,TRUE);
		VPos=vpos*(double)maxY/100.0;
        if(SetUp){
		InvalidateRect(hwnd,NULL,1);
        };
        if(Karnaugh)SetFocus(karnaughwind);
        if(Help)SetFocus(helpwind);
		/* Scroll Text */
		/* ScrollWindow(hwnd,0,-lfHeight*vpos,
		(CONST RECT *) NULL, (CONST RECT *)NULL); */
		            }
		break;
		
		case WM_HSCROLL:
		switch(LOWORD(wParam)){
		  case SB_TOP:
		  hpos=0.0;
		  break;
		
		  case SB_BOTTOM:
		  hpos=(double)width;
		  break;
		
		  case SB_LINEDOWN:
		  hpos++;
		  if(hpos>width)hpos=(double)width;
		  break;
		
		  case SB_LINEUP:
		  hpos--;
		  if(hpos<0)hpos=0.0;
		  break;
		
		  case SB_THUMBPOSITION:
		  hpos=(double)HIWORD(wParam); /* Get current position */
		  break;
		
		  case SB_THUMBTRACK:
		  hpos=(double)HIWORD(wParam); /* Get current position */
		  break;
		
		  case SB_PAGEDOWN:
		  hpos+=20.0;
		  if(hpos>width)hpos=(double)width;
		  break;
		
		  case SB_PAGEUP:
		  hpos-=20.0;
		  if(hpos<0)hpos=0.0;
		  break;
		      }
		/* Update Vertical Bar Position */
		if(hpos!=Oldhpos){
		Oldhpos=hpos;
		si.cbSize=sizeof(SCROLLINFO);
		si.nMin=0;
		si.nMax=width;
		si.fMask=SIF_POS;
		si.nPos=(int)hpos;
		SetScrollInfo(hwnd,SB_HORZ,&si,TRUE);
		HPos=hpos*(double)maxX/100.0;
		if(SetUp){
		InvalidateRect(hwnd,NULL,1);
        };
        if(Karnaugh)SetFocus(karnaughwind);
        if(Help)SetFocus(helpwind);
		/* Scroll Text */
		/* ScrollWindow(hwnd,0,-lfHeight*vpos,
		(CONST RECT *) NULL, (CONST RECT *)NULL); */
		            }
		break;

  case WM_QUIT:
  break;
  case WM_CLOSE:
  if(Help)DestroyWindow(helpwind);
  if(Karnaugh)DestroyWindow(karnaughwind);
  if(Logic)DestroyWindow(logicwind);
  Help=Karnaugh=Logic=FALSE;
  PostQuitMessage (0);
  exit(0);
  break;		
  case WM_DESTROY:
          if(Help)DestroyWindow(helpwind);
          if(Karnaugh)DestroyWindow(karnaughwind);
          if(Logic)DestroyWindow(logicwind);
          Help=Karnaugh=Logic=FALSE;
            PostQuitMessage (0);
  break;          
       /* send a WM_QUIT to the message queue */
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


LRESULT CALLBACK DialogFunc4(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam)
{OPENFILENAME ofn;
 static long lfHeight;
 static SCROLLINFO si;
 static int vpos;
 static RECT rcClient;
 static PAINTSTRUCT ps;
 static HDC hdc,memPrDC;
 static HFONT hf;
 static HBRUSH hBrush;
 HMENU hMenu;
 HMENU hSubMenu;
 static int lines=0,copies,YY,line=5,X,i;
 static PRINTDLG printdlg;
 static DOCINFO docinfo;
 static HPEN hPen;
 int ii,jj;
 double xii,yjj;
 TEXTMETRIC tm;
 
    switch(message)
    {
		case WM_CREATE:
			g_hfkarnaughFont = CreateFont(70,0,0,0,0,FW_NORMAL,
			0,0,0,ANSI_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH | FF_DONTCARE, 0);
			hdc=GetDC(hdwnd);
			memDC4=CreateCompatibleDC(hdc);
			hbit2=CreateCompatibleBitmap(hdc,435,435);
			SelectObject(memDC4,hbit2);
			hBrush=(HBRUSH)GetStockObject(WHITE_BRUSH);
			SelectObject(memDC4,hBrush);
			PatBlt(memDC4,0,0,435,435,PATCOPY);
	    SetBkColor(memDC4,RGB(255,255,255));
 	    SetTextColor(memDC4,RGB(0,0,0));
	    hPen=CreatePen(PS_SOLID,5,RGB(0,0,0));
	    SelectObject(memDC4,hPen);
	    for(jj=0;jj<400;jj+=100)for(ii=0;ii<400;ii+=100)Rectangle(memDC4,ii+25,jj+25,ii+125,jj+125);
	    MoveToEx(memDC4,0,0,NULL);LineTo(memDC4,25,25);
	    SelectObject(memDC4,g_hfkarnaughFont);
	    GetTextMetrics(hdc,&tm);
	    SetTextColor(memDC4,RGB(0,0,0));
	    for(jj=0;jj<400;jj+=100)for(ii=0;ii<400;ii+=100){
	    	TextOut(memDC4,50+ii-tm.tmAveCharWidth/2,55+jj-tm.tmHeight/2,((KarnaughMap[jj/100][ii/100]) ? "1" : "0"),1);
	     }
	    DeleteObject(g_hfkarnaughFont);
	    g_hfkarnaughFont = CreateFont(22,0,0,0,0,FW_NORMAL,
			0,0,0,ANSI_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH | FF_DONTCARE, 0);
		SelectObject(memDC4,g_hfkarnaughFont);
		GetTextMetrics(hdc,&tm);
		SetTextColor(memDC4,RGB(255,0,0));
		TextOut(memDC4,30,0,"A",1);
		SetTextColor(memDC4,RGB(0,0,255));
		TextOut(memDC4,30+2*tm.tmAveCharWidth,0,"B",1);
		SetTextColor(memDC4,RGB(0,255,0));
		TextOut(memDC4,10-tm.tmAveCharWidth,20,"C",1);
		SetTextColor(memDC4,RGB(255,95,63));
		TextOut(memDC4,15,20,"D",1);
		for(ii=0;ii<4;ii++){
		SetTextColor(memDC4,RGB(255,0,0));
		TextOut(memDC4,75-tm.tmAveCharWidth+ii*100-tm.tmAveCharWidth/2,0,((ii/2) ? "1" : "0"),1);	
        SetTextColor(memDC4,RGB(0,0,255));
		TextOut(memDC4,75+tm.tmAveCharWidth+ii*100-tm.tmAveCharWidth/2,0,((((ii+1)/2)%2) ? "1" : "0"),1);
	    SetTextColor(memDC4,RGB(0,255,0));
		TextOut(memDC4,0,75+ii*100-tm.tmHeight/2,((ii/2) ? "1" : "0"),1);	
        SetTextColor(memDC4,RGB(255,95,63));
		TextOut(memDC4,2*tm.tmAveCharWidth,75+ii*100-tm.tmHeight/2,((((ii+1)/2)%2) ? "1" : "0"),1);
		}
	    InvalidateRect(hdwnd, NULL, TRUE);
	    DeleteObject(g_hfkarnaughFont);
	    ReleaseDC(hdwnd,hdc);
		break;
		case WM_CHAR:
		if(Accept)keycode=(char)wParam;
		break;
		case WM_LBUTTONDOWN:
		hdc=GetDC(hdwnd);
		g_hfkarnaughFont = CreateFont(70,0,0,0,0,FW_NORMAL,
			0,0,0,ANSI_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH | FF_DONTCARE, 0);
		ii=LOWORD(lParam);jj=HIWORD(lParam);
		xii=(double)(ii-25)/100.0;yjj=(double)(jj-25)/100.0;
		if(xii>=0.0 && yjj>=0.0 && !Finished){
		if(!KarnaughSetUp){KarnaughSetUp=TRUE;hMenu=GetMenu(mainwind);
		EnableMenuItem(hMenu,IDM_RUNQUINE,MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(hMenu,IDM_RESET,MF_BYCOMMAND | MF_ENABLED);
		DrawMenuBar(mainwind);
		}
		ii=(int)xii;jj=(int)yjj;	
		KarnaughMap[jj][ii]=!KarnaughMap[jj][ii];
		ii*=100;jj*=100;
		SelectObject(memDC4,g_hfkarnaughFont);
	    GetTextMetrics(hdc,&tm);
	    SetBkColor(memDC4,RGB(255,255,255));
		SetTextColor(memDC4,RGB(0,0,0));
		TextOut(memDC4,50+ii-tm.tmAveCharWidth/2,55+jj-tm.tmHeight/2,((KarnaughMap[jj/100][ii/100]) ? "1" : "0"),1);
		InvalidateRect(hdwnd, NULL, FALSE);
		};
		DeleteObject(g_hfkarnaughFont);
	    ReleaseDC(hdwnd,hdc);
	    break;
		case WM_CLOSE:
            Karnaugh=FALSE;
		    if(Logic)DestroyWindow(logicwind);
		    Logic=FALSE;
		    hMenu=GetMenu(mainwind);
		    hdc=GetDC(hdwnd);
		    if(!Finished)EnableMenuItem(hMenu,IDM_GSHOW,MF_BYCOMMAND | MF_ENABLED);
		    EnableMenuItem(hMenu,IDM_RUNQUINE,MF_BYCOMMAND | MF_GRAYED);
		    ReleaseDC(hdwnd,memDC4);
		    DeleteObject(hbit2);
		    DestroyWindow(hdwnd);
			PostQuitMessage(0);
		break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				/* case ID_FILE_EXIT:
				    DestroyWindow(hdwnd);
					PostMessage(hdwnd, WM_CLOSE, 0, 0);
				break; */
				case IDM_GRESET:
				if(!Finished){
				Reset=TRUE;
		KarnaughSetUp=FALSE;hMenu=GetMenu(mainwind);
		EnableMenuItem(hMenu,IDM_RUNQUINE,MF_BYCOMMAND | MF_GRAYED);
		DrawMenuBar(mainwind);		
		SetBkColor(memDC4,RGB(255,255,255));
	    hPen=CreatePen(PS_SOLID,5,RGB(0,0,0));
	    SelectObject(memDC4,hPen);
	    hdc=GetDC(hdwnd);
		g_hfkarnaughFont = CreateFont(70,0,0,0,0,FW_NORMAL,
			0,0,0,ANSI_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH | FF_DONTCARE, 0);
		SelectObject(memDC4,g_hfkarnaughFont);
	    GetTextMetrics(hdc,&tm);
	    SetTextColor(memDC4,RGB(0,0,0));
	    for(jj=0;jj<400;jj+=100)for(ii=0;ii<400;ii+=100){
	    	KarnaughMap[jj/100][ii/100]=0;
	    	TextOut(memDC4,50+ii-tm.tmAveCharWidth/2,55+jj-tm.tmHeight/2,((KarnaughMap[jj/100][ii/100]) ? "1" : "0"),1);
	     }
		DeleteObject(g_hfkarnaughFont);
		ReleaseDC(hdwnd,hdc); 	
	    InvalidateRect(hdwnd, NULL, TRUE);
				};
	    Reset=FALSE;
				break;
				case IDM_GHIDE:
				Karnaugh=FALSE;
			hdc=GetDC(hdwnd);
		g_hfkarnaughFont = CreateFont(70,0,0,0,0,FW_NORMAL,
			0,0,0,ANSI_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH | FF_DONTCARE, 0);	
			hMenu=GetMenu(mainwind);
            EnableMenuItem(hMenu,IDM_GSHOW,MF_BYCOMMAND | MF_ENABLED);	
		    ReleaseDC(hdwnd,memDC4);
		    DeleteObject(hbit2);
		    DeleteObject(g_hfkarnaughFont);
			DestroyWindow(hdwnd);
				break;
				case IDM_GSAVE:
				Reset=TRUE;
			ZeroMemory(&ofn, sizeof(ofn));
    strcpy(szFileOut,"BMPKarnaugh");
    ofn.lStructSize = sizeof(ofn); // SEE NOTE BELOW
    ofn.hwndOwner = hdwnd;
    ofn.lpstrFilter = "Bitmap Files (*.bmp)\0*.bmp\0All Files (*.*)\0*.*\0";
    ofn.lpstrFile = szFileOut;
    ofn.nMaxFile = MAX_PATH;
    ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "bmp";

    if(GetSaveFileName(&ofn))
    {
     /* ReleaseDC(hwnd,hdc1);
     hdc1=GetDC(hwnd); */
     CreateBitmapInfoStruct(hdwnd,hbit2);
     CreateBMPFile(hdwnd,szFileOut,pbmi,
                  hbit2,memDC4);
     // SaveBitmapToFile(hBit1,szFileOut,hwnd);
            }
            Reset=FALSE;
			break;
			case IDM_GPRINT:
			Reset=TRUE;
			YY=0;
                /* Initialise PRINTDLG structure */
                PrintInit(&printdlg,hdwnd);
                if(!PrintDlg(&printdlg))break;
                docinfo.cbSize=sizeof(DOCINFO);
                docinfo.lpszDocName="Karnaugh BMP";
                docinfo.lpszOutput=NULL;
                docinfo.lpszDatatype=NULL;
                docinfo.fwType=0;

                if(!(GetDeviceCaps(printdlg.hDC, RASTERCAPS)
                   & (RC_BITBLT | RC_STRETCHBLT))){
                    MessageBox(hwnd,"Your Printer Cannot Print Raster Images",
                    "Message from QuineMcC",MB_OK);
                    break;
                      }
                /* create a memory DC compatible with the printer */
                // memPrDC=CreateCompatibleDC(printdlg.hDC);
                /* create a bitmap compatible with the printer DC */
                // hBit3=CreateCompatibleBitmap(printdlg.hDC,maxX,maxY);
                // SelectObject(memPrDC,hBit3);
                /* put bitmap image into memory DC */
                // SelectObject(memDC3,hBit1);
                /* copy bitmap to printer-compatible DC */
                // BitBlt(memPrDC,0,0,maxX,maxY,memDC3,0,0,SRCCOPY);
                /* obtain pixels-per-inch */
                VidXPPI=GetDeviceCaps(memDC4,LOGPIXELSX);
                VidYPPI=GetDeviceCaps(memDC4,LOGPIXELSY);
                PrXPPI=GetDeviceCaps(printdlg.hDC,LOGPIXELSX);
                PrYPPI=GetDeviceCaps(printdlg.hDC,LOGPIXELSY);
                /* get scaling ratios */
                Xratio=PrXPPI/VidXPPI;
                Yratio=PrYPPI/VidYPPI;
                /* restore virtual window */
                // SelectObject(memDC3,hbit);
                StartDoc(printdlg.hDC,&docinfo);
                for(copies=0; copies<printdlg.nCopies;copies++){
                    StartPage(printdlg.hDC);
                    /* copy bitmap to print DC as-is
                    BitBlt(printdlg.hDC,0,0,width,height,
                    memPrDC,0,0,SRCCOPY); */
                    /* copy bitmap while maintaining persective */
                    StretchBlt(printdlg.hDC,0,maxY+100,
                    (int)((double)425*Xratio),
                    (int)((double)425*Yratio),
                    memDC4,0,0,
                    425,425,
                    SRCCOPY);
                    EndPage(printdlg.hDC);
                 };
                EndDoc(printdlg.hDC);
                DeleteDC(memPrDC);
                DeleteDC(printdlg.hDC);
                MessageBox(hwnd,"Click \'OK\' when Print is Complete","Message from QuineMcC",MB_OK);
                if(Help)SetFocus(helpwind);
                SetFocus(hdwnd);
                Reset=FALSE;
			break;
				case ID_FORMAT_FONT:
					DoSelectProgFont(hdwnd);

					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
				case ID_FORMAT_DEFAULTGUIFONT:
					DeleteObject(g_hfkarnaughFont);
					g_hfkarnaughFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
					
					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
				case ID_FORMAT_TEST:
				{   HDC hdc;
				    HFONT hf;
					
					hdc = GetDC(NULL);
					lfHeight = -MulDiv(12, GetDeviceCaps(hdc, LOGPIXELSY), 72);
					ReleaseDC(NULL, hdc);

					hf = CreateFont(lfHeight, 0, 0, 0, 0, TRUE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");

					if(hf)
					{
						DeleteObject(g_hfFont);
						g_hfkarnaughFont = hf;
					}
					else
					{
						MessageBox(hdwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
					}					
					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				}
				break;
				case ID_FORMAT_BACKGROUNDCOLOUR:
					DoSelectProgColour(hdwnd);

					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
				case ID_FORMAT_OPAQUE:
					g_bkarnaughOpaque = !g_bkarnaughOpaque;

					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
			}
		break;
		case WM_INITMENUPOPUP:
			CheckMenuItem((HMENU)wParam, ID_FORMAT_OPAQUE, MF_BYCOMMAND | ( g_bOpaque ? MF_CHECKED : MF_UNCHECKED));
		break;
		
		case WM_PAINT:
		{
			
			hdc = BeginPaint(hdwnd, &ps);

			GetClientRect(hdwnd, &rcClient);

            BitBlt(hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right-ps.rcPaint.left,ps.rcPaint.bottom-ps.rcPaint.top,memDC4,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY);

			EndPaint(hdwnd, &ps);
		}
		break;
		
		case WM_QUIT:
		break;
		
		case WM_DESTROY:
		    if(Karnaugh)DestroyWindow(hdwnd);
		    Karnaugh=FALSE;
		    ReleaseDC(hdwnd,memDC4);
			DeleteObject(hbit2);
			PostQuitMessage(0);
		break;
		
		default:
			return DefWindowProc(hdwnd, message, wParam, lParam);
	}
	return 0;
}

int FontLength(char *in,HDC hdc)
{SIZE size;
int i,len=0;
char ch[2];
for(i=0;in[i]!='\0';i++){ch[0]=in[i];ch[1]='\0';
GetTextExtentPoint32(hdc,ch,1,&size);len+=size.cx;}
return(len);
}

LRESULT CALLBACK WndProc4(HWND hdwnd, UINT message, WPARAM wParam, LPARAM lParam)
{OPENFILENAME ofn;
 static long lfHeight;
 static SCROLLINFO si;
 static int vpos;
 static RECT rcClient;
 static PAINTSTRUCT ps;
 static HDC hdc,memPrDC;
 static HFONT hf;
 static HBRUSH hBrush;
 HMENU hMenu;
 HMENU hSubMenu;
 static int lines=0,copies,YY,line=5,X,i;
 static PRINTDLG printdlg;
 static DOCINFO docinfo;
 static HPEN hPen;
 int ii,jj;
 double xii,yjj;
 TEXTMETRIC tm;
 static SIZE size;
 static char ch[2];
 static int flag, len2;

 
    switch(message)
    {
		case WM_CREATE:
	    g_hfLogicFont = CreateFont(22,0,0,0,0,FW_NORMAL,
			0,0,0,ANSI_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH | FF_DONTCARE, 0);
			hdc=GetDC(hdwnd);
			memDC5=CreateCompatibleDC(hdc);
			hbit4=CreateCompatibleBitmap(hdc,maxX,35);
			SelectObject(memDC5,hbit4);
			hBrush=(HBRUSH)GetStockObject(WHITE_BRUSH);
			SelectObject(memDC5,hBrush);
			PatBlt(memDC5,0,0,maxX,35,PATCOPY);
            SetTextColor(memDC5,RGB(0,0,0));
	        hPen=CreatePen(PS_SOLID,5,RGB(0,0,0));
	        SelectObject(memDC5,hPen);
			SelectObject(memDC5,g_hfLogicFont);
			len2=FontLength(logicstring,memDC5);
			SetBkColor(memDC5,RGB(255,255,255));
			Logiclen=maxX/2-len2/2;flag=0;
			for(i=0;logicstring[i]!='\0' && !flag;i++){
			if(logicstring[i]=='0'){SetTextColor(memDC5,RGB(255,0,0));
			TextOut(memDC5,Logiclen,10,logicstring,strlen(logicstring));flag=1;}
			else if(logicstring[i]=='1'){SetTextColor(memDC5,RGB(0,255,0));
			TextOut(memDC5,Logiclen,10,logicstring,strlen(logicstring));flag=1;} else {
			if(logicstring[i]=='A')SetTextColor(memDC5,RGB(255,0,0));
			else if(logicstring[i]=='B')SetTextColor(memDC5,RGB(0,0,255));
			else if(logicstring[i]=='C')SetTextColor(memDC5,RGB(0,255,0));
			else if(logicstring[i]=='D')SetTextColor(memDC5,RGB(255,95,63));
			else SetTextColor(memDC5,RGB(0,0,0));
			ch[0]=logicstring[i];ch[1]='\0';
			TextOut(memDC5,Logiclen,10,ch,1);
			InvalidateRect(hdwnd,NULL,0);
			GetTextExtentPoint32(memDC5,ch,1,&size);Logiclen+=size.cx;
			 }
			}
			InvalidateRect(hdwnd,NULL,0);
			ReleaseDC(hdwnd,hdc);
		break;
		case WM_CHAR:
		if(Accept)keycode=(char)wParam;
		break;
		case WM_CLOSE:
            Logic=FALSE;
		    ReleaseDC(hdwnd,memDC5);
		    DeleteObject(hbit4);
		    DestroyWindow(hdwnd);
			PostQuitMessage(0);
		break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				/* case ID_FILE_EXIT:
				    DestroyWindow(hdwnd);
					PostMessage(hdwnd, WM_CLOSE, 0, 0);
				break; */
				case IDM_ISAVE:
				Reset=TRUE;
			ZeroMemory(&ofn, sizeof(ofn));
    strcpy(szFileOut,"BMPLogic");
    ofn.lStructSize = sizeof(ofn); // SEE NOTE BELOW
    ofn.hwndOwner = hdwnd;
    ofn.lpstrFilter = "Bitmap Files (*.bmp)\0*.bmp\0All Files (*.*)\0*.*\0";
    ofn.lpstrFile = szFileOut;
    ofn.nMaxFile = MAX_PATH;
    ofn.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "bmp";

    if(GetSaveFileName(&ofn))
    {
     /* ReleaseDC(hwnd,hdc1);
     hdc1=GetDC(hwnd); */
     CreateBitmapInfoStruct(hdwnd,hbit4);
     CreateBMPFile(hdwnd,szFileOut,pbmi,
                  hbit4,memDC5);
     // SaveBitmapToFile(hBit1,szFileOut,hwnd);
            }
            Reset=FALSE;
			break;
			case IDM_IPRINT:
			Reset=TRUE;
			YY=0;
                /* Initialise PRINTDLG structure */
                PrintInit(&printdlg,hdwnd);
                if(!PrintDlg(&printdlg))break;
                docinfo.cbSize=sizeof(DOCINFO);
                docinfo.lpszDocName="Karnaugh BMP";
                docinfo.lpszOutput=NULL;
                docinfo.lpszDatatype=NULL;
                docinfo.fwType=0;

                if(!(GetDeviceCaps(printdlg.hDC, RASTERCAPS)
                   & (RC_BITBLT | RC_STRETCHBLT))){
                    MessageBox(hwnd,"Your Printer Cannot Print Raster Images",
                    "Message from QuineMcC",MB_OK);
                    break;
                      }
                /* create a memory DC compatible with the printer */
                // memPrDC=CreateCompatibleDC(printdlg.hDC);
                /* create a bitmap compatible with the printer DC */
                // hBit3=CreateCompatibleBitmap(printdlg.hDC,maxX,maxY);
                // SelectObject(memPrDC,hBit3);
                /* put bitmap image into memory DC */
                // SelectObject(memDC3,hBit1);
                /* copy bitmap to printer-compatible DC */
                // BitBlt(memPrDC,0,0,maxX,maxY,memDC3,0,0,SRCCOPY);
                /* obtain pixels-per-inch */
                VidXPPI=GetDeviceCaps(memDC5,LOGPIXELSX);
                VidYPPI=GetDeviceCaps(memDC5,LOGPIXELSY);
                PrXPPI=GetDeviceCaps(printdlg.hDC,LOGPIXELSX);
                PrYPPI=GetDeviceCaps(printdlg.hDC,LOGPIXELSY);
                /* get scaling ratios */
                Xratio=PrXPPI/VidXPPI;
                Yratio=PrYPPI/VidYPPI;
                /* restore virtual window */
                // SelectObject(memDC3,hbit);
                StartDoc(printdlg.hDC,&docinfo);
                for(copies=0; copies<printdlg.nCopies;copies++){
                    StartPage(printdlg.hDC);
                    /* copy bitmap to print DC as-is
                    BitBlt(printdlg.hDC,0,0,width,height,
                    memPrDC,0,0,SRCCOPY); */
                    /* copy bitmap while maintaining persective */
                    StretchBlt(printdlg.hDC,176-Logiclen,maxY+100,
                    (int)((double)maxX*Xratio),
                    (int)((double)40*Yratio),
                    memDC5,0,0,
                    maxX,40,
                    SRCCOPY);
                    EndPage(printdlg.hDC);
                 };
                EndDoc(printdlg.hDC);
                DeleteDC(memPrDC);
                DeleteDC(printdlg.hDC);
                MessageBox(hwnd,"Click \'OK\' when Print is Complete","Message from QuineMcC",MB_OK);
                if(Help)SetFocus(helpwind);
                if(Karnaugh)SetFocus(karnaughwind);
                SetFocus(hdwnd);
                Reset=FALSE;
			break;				
				case ID_FORMAT_FONT:
					DoSelectLogicFont(hdwnd);

					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
				case ID_FORMAT_DEFAULTGUIFONT:
					DeleteObject(g_hfLogicFont);
					g_hfLogicFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
					
					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
				case ID_FORMAT_TEST:
				{   HDC hdc;
				    HFONT hf;
					
					hdc = GetDC(NULL);
					lfHeight = -MulDiv(12, GetDeviceCaps(hdc, LOGPIXELSY), 72);
					ReleaseDC(NULL, hdc);

					hf = CreateFont(lfHeight, 0, 0, 0, 0, TRUE, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");

					if(hf)
					{
						DeleteObject(g_hfLogicFont);
						g_hfLogicFont = hf;
					}
					else
					{
						MessageBox(hdwnd, "Font creation failed!", "Error from QuineMcC", MB_OK | MB_ICONEXCLAMATION);
					}					
					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				}
				break;
				case ID_FORMAT_BACKGROUNDCOLOUR:
					DoSelectLogicColour(hdwnd);

					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
				case ID_FORMAT_OPAQUE:
					g_blogicOpaque = !g_blogicOpaque;

					InvalidateRect(hdwnd, NULL, TRUE);
					UpdateWindow(hdwnd);
				break;
			}
		break;
		case WM_INITMENUPOPUP:
			CheckMenuItem((HMENU)wParam, ID_FORMAT_OPAQUE, MF_BYCOMMAND | ( g_bOpaque ? MF_CHECKED : MF_UNCHECKED));
		break;
		
		case WM_PAINT:
		{
			
			hdc = BeginPaint(hdwnd, &ps);

			GetClientRect(hdwnd, &rcClient);

            BitBlt(hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right-ps.rcPaint.left,ps.rcPaint.bottom-ps.rcPaint.top,memDC5,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY);

			EndPaint(hdwnd, &ps);
		}
		break;
		
		case WM_QUIT:
		break;
		
		case WM_DESTROY:
		    if(Logic)DestroyWindow(hdwnd);
		    Logic=FALSE;
		    ReleaseDC(hdwnd,memDC5);
			DeleteObject(hbit4);
			PostQuitMessage(0);
		break;
		
		default:
			return DefWindowProc(hdwnd, message, wParam, lParam);
	}
	return 0;
}

